﻿' developed by mkaatr
' this class is used to render boxes that could have many different useful items
Public Class Box
    Inherits BaseCreature       ' the class inherts from the BaseCreature class so it has all the physical behaviour like any character


    ' the possible contents of the box
    Public Enum BoxContent
        Empty = 0               ' could be empty
        Shoe = 1                ' could contains a shoe for increasing speed
        Health = 2              ' could contains first aid kit to increase health
        Dynamite = 3            ' could include explosives
        BounceingBomb = 4       ' could include bouncing bombs - which is another type of explosives
        Glove = 5               ' could contains gloves which could help you climb trees
        Axe = 6                   ' could contain axes
    End Enum


    Public ItemType As BoxContent   ' add a property that describes what is in the box

    ' the new constructor
    Public Sub New(ByVal ContentType As BoxContent, ByVal X As Integer, ByVal Y As Integer)
        IsAffactedByArrow = False
        IsAffactedByExplosion = False

        CreatureType = CretureTypeEnum.CreatureType_Box         ' set the type of creature - it is a box
        ItemType = ContentType                                  ' set the items in the box
        IsRendered = True                                       ' it should be rendered
        MapX = X                                                ' set x location within the map
        MapY = Y                                                ' set y location within the map
        AccX = 0                                                ' this is a box so it should not have speed
        AccY = 0
        RenderStage = 0                                         ' there is only one sprite
        CreatureWidth = 16                                      ' the size of the sprite
        CreatureHeight = 16
        HalfWidth = CreatureWidth \ 2
        HalfHeight = CreatureHeight \ 2
        IsAffectedByGravity = True                              ' it should be affacted by gravity
        CanBounce = False                                       ' should not bounce
        Gravity = 0.1                                           ' the effect of gravity
        MaxGravity = 10                                         ' max speed for the box

        StandOnBlocks = New List(Of MapBlockType)
        SolidBlocks = New List(Of MapBlockType)           ' things that could prevent the box from falling
        SolidBlocks.Add(MapBlockType.BrickBlock)
        SolidBlocks.Add(MapBlockType.RocksBlock)
        SolidBlocks.Add(MapBlockType.GrassBlock)
        SolidBlocks.Add(MapBlockType.BreakableBrick)

        ' set the shape of the box based on its contents
        If ItemType = BoxContent.Dynamite Then CreatureSprites = GameSpritesObject.DynamiteBoxSprite
        If ItemType = BoxContent.Empty Then CreatureSprites = GameSpritesObject.EmptyBoxSprite
        If ItemType = BoxContent.Shoe Then CreatureSprites = GameSpritesObject.ShoeBoxSprite
        If ItemType = BoxContent.Health Then CreatureSprites = GameSpritesObject.HealthBoxSprite
        If ItemType = BoxContent.BounceingBomb Then CreatureSprites = GameSpritesObject.BombBoxSprite
        If ItemType = BoxContent.Glove Then CreatureSprites = GameSpritesObject.GloveBoxSprite
        If ItemType = BoxContent.Axe Then CreatureSprites = GameSpritesObject.AxeBoxSprite

        CreatureSprites.CurrentFrameIndex = 0

    End Sub


End Class
