﻿' developed by mkaatr 2011
' http://www.mka-soft.com

Public Class Hero                                                       ' our hero class
    Inherits BaseCreature



    Public MaxHP As Integer = 100                                       ' max possible hp value. this could increase when he becomes stronger
    Public CurrentHP As Integer = 100                                   ' the current hp value
    Public Unaffected As Single = 100                                   ' a counter that counts for how long should our hero stays in unaffacted mode - if he was attacked by enemies
    Public HasShoe As Boolean = False                                   ' does he have a shoe?
    Public DynamiteCount As Integer = 0                                 ' how many dynamite sticks does he has?
    Public BouncingBombCount As Integer = 0                             ' how many bouncing bombs does he has?
    Public CurrentWeapon As Box.BoxContent = Box.BoxContent.Empty       ' what kind of weapon does he carry?
    Public HasGlove As Boolean = False                                  ' deos he have a glove?
    Public AirCounter As Long = System.Environment.TickCount            ' the air counter
    Public Air As Integer = 30000                                       ' for how long your charactor could hold its breath under water
    Public IsInDemoMode As Boolean = False                              ' is your charactor in demo mode?
    Public RunningSound As AgateLib.AudioLib.SoundBuffer                ' the sound effects for our charactor
    Public LastIsNotStandingIndex As Long = 0
    Public CanSwitchWithOtherPlayer As Boolean                          ' this method checks to see if you can swaitch with other player
    Public HasAxe As Boolean = False
    Public HeroAxeSprite As AgateLib.Sprites.Sprite
    Public IsUsingAxe As Boolean
    Public IsUsingAxeTimeStamp As Long

    Public Class HistoryItem
        Public MapX As Single
        Public MapY As Single
        Public IsStanding As Boolean
        Public RenderStage As Integer
    End Class

    Public HistoryQueue As List(Of HistoryItem)
    Public HistoryQueueIndex As Integer


    Public Sub New()
        IsAffactedByArrow = True
        IsAffactedByExplosion = True

        CreatureType = CretureTypeEnum.CreatureType_Hero                ' type of creature
        IsRendered = True                                               ' rendered
        MapX = 50                                                       ' default x,y, speed, etc
        MapY = 30
        AccY = 0

        ' specify type of blocks you could stand on
        SolidBlocks = New List(Of MapBlockType)
        StandOnBlocks = New List(Of MapBlockType)
        SolidBlocks.Add(MapBlockType.BrickBlock)
        SolidBlocks.Add(MapBlockType.RocksBlock)
        SolidBlocks.Add(MapBlockType.GrassBlock)
        SolidBlocks.Add(MapBlockType.BreakableBrick)
        Direction = CreatueXDirection.RightDirection                    ' looking to the right
        RenderStage = 0

        CreatureWidth = 18                                              ' the width of the character
        Me.SpriteXShift = -2                                            ' shift by -2

        CreatureHeight = 32                                             ' the height
        HalfWidth = CreatureWidth \ 2
        HalfHeight = CreatureHeight \ 2
        IsAffectedByGravity = True
        CanBounce = False
        Gravity = 0.1
        MaxGravity = 10


        CreatureSprites = GameSpritesObject.HeroSprite
        CreatureSprites.CurrentFrameIndex = 1


        ControlMode = CreatureControlModeEnum.ControlModePlayer

        ' load audio file
        Me.RunningSound = GameSoundsObject.RunningSound


        HistoryQueue = New List(Of HistoryItem)
        Dim I As Integer
        For I = 0 To 100
            HistoryQueue.Add(New HistoryItem)
        Next
        HistoryQueueIndex = 0
        CanSwitchWithOtherPlayer = False
        Me.HeroAxeSprite = GameSpritesObject.HeroAxeSprite
    End Sub

    Public Overrides Sub UpdateLocation(ByVal Info As Object, ByVal UserInput As GameInputClass)

        If IsUsingAxe Then
            If System.Environment.TickCount - IsUsingAxeTimeStamp > 3000 Then
                IsUsingAxe = False

                ' also check to see if the map box could be affacted
                Dim MMX As Long = MapX
                Dim MMY As Long = MapY + 8
                If Me.Direction = CreatueXDirection.RightDirection Then
                    MMX = MapX + 8
                Else
                    MMX = MapX - 8
                End If
                MMX = MMX \ 16
                MMY = MMY \ 16
                If GameMapObject.GameMap(MMX, MMY) = MapBlockType.BreakableBrick Then
                    GameMapObject.GameMap(MMX, MMY) = MapBlockType.EmptyBlock
                End If
            Else
                Exit Sub
            End If
        End If

        ' this flag is used to indicate motion
        Dim PlayRuningSoungFlag As Boolean = False

        ' this was added for demo purpose
        If Not IsInDemoMode Then

            ' check to see if the character is covered with water
            If Me.CoveredWithWater Then
                Me.Air = 30000 - (System.Environment.TickCount - Me.AirCounter)
                If Me.Air <= 0 Then
                    Me.CurrentHP = Me.CurrentHP - 5
                End If
            Else
                Me.Air = 30000
                Me.AirCounter = System.Environment.TickCount
            End If

            ' used to switch to the heroine
            If ControlMode = CreatureControlModeEnum.ControlModePlayer AndAlso _
               UserInput.Is3 Then
                If CanSwitchWithOtherPlayer AndAlso Info IsNot Nothing Then
                    Me.ControlMode = CreatureControlModeEnum.ControlModeSwithchedToPlayer
                    Dim HRN As Heroine = Info
                    HRN.ControlMode = CreatureControlModeEnum.ControlModePlayer
                End If
            End If

            ' used to make the heoine follow the hero as soon as he touchs her
            If ControlMode = CreatureControlModeEnum.ControlModePlayer AndAlso _
               UserInput.Is5 Then
                If CanSwitchWithOtherPlayer AndAlso Info IsNot Nothing Then
                    Dim HRN As Heroine = Info
                    HRN.ControlMode = CreatureControlModeEnum.ControlModeWaitForPlayer
                End If
            End If


            ' the the up button is presses
            If ControlMode = CreatureControlModeEnum.ControlModePlayer AndAlso _
               UserInput.IsUp Then

                ' check and make sure that the person is standing on a brick
                If IsStanding Then
                    AccY = -3.1
                End If
            End If

            ' the accx is affacted by keyboard input only
            AccX = 0

            ' the the right button is presses
            If ControlMode = CreatureControlModeEnum.ControlModePlayer AndAlso _
               UserInput.IsRight Then
                AccX = +3
                If HasShoe Then
                    AccX += 1
                End If
                Me.Direction = CreatueXDirection.RightDirection
            End If

            ' the the left button is presses
            If ControlMode = CreatureControlModeEnum.ControlModePlayer AndAlso _
               UserInput.IsLeft Then
                AccX = -3
                If HasShoe Then
                    AccX -= 1
                End If
                Me.Direction = CreatueXDirection.LeftDirection
            End If

            ' the current weapon is dynamite
            If ControlMode = CreatureControlModeEnum.ControlModePlayer AndAlso _
                UserInput.Is1 Then
                Me.CurrentWeapon = Box.BoxContent.Dynamite
            End If

            ' the current weapon is bouncing bomb
            If ControlMode = CreatureControlModeEnum.ControlModePlayer AndAlso _
               UserInput.Is2 Then
                Me.CurrentWeapon = Box.BoxContent.BounceingBomb
            End If

            ' the current weapon is axe
            If ControlMode = CreatureControlModeEnum.ControlModePlayer AndAlso _
               UserInput.Is6 Then
                Me.CurrentWeapon = Box.BoxContent.Axe
            End If

        Else
            ' if is in demo mode, then set the direction based on speed
            If AccX > 0 Then Me.Direction = CreatueXDirection.RightDirection
            If AccX < 0 Then Me.Direction = CreatueXDirection.LeftDirection
        End If

        ' the unaffacted counter is always updated
        Unaffected = Unaffected - 1
        If Unaffected < 0 Then
            Unaffected = 0
        End If

        Dim OldX = Me.MapX

        MyBase.UpdateLocation(Info, Nothing)

        ' this part is used to select the correct sprite.
        ' check if the char is jumping
        If Not IsStanding Then
            If Direction = CreatueXDirection.LeftDirection Then
                Me.RenderStage = 7
            Else
                Me.RenderStage = 3
            End If
        ElseIf AccX <> 0 Then
            Dim STG As Integer = (MapX \ 10) Mod 4
            If STG = 0 Then Me.RenderStage = 2
            If STG = 1 Then Me.RenderStage = 0
            If STG = 2 Then Me.RenderStage = 2
            If STG = 3 Then Me.RenderStage = 1
            If Direction = CreatueXDirection.LeftDirection Then
                Me.RenderStage += 4
            End If
        Else
            If Direction = CreatueXDirection.LeftDirection Then
                Me.RenderStage = 6
            Else
                Me.RenderStage = 2
            End If
        End If

        ' check if the sound should be played
        If OldX <> Me.MapX And IsStanding Then
            PlayRuningSoungFlag = True
        End If

        ' next based on the motion flag check the sound
        If PlayRuningSoungFlag And Not RunningSound.IsPlaying Then
            RunningSound.Play()
        ElseIf Not PlayRuningSoungFlag And RunningSound.IsPlaying Then
            RunningSound.Stop()
        End If

        ' used for tracking the history of the player
        Dim Tmp As HistoryItem = HistoryQueue(HistoryQueueIndex)

        If Not IsStanding Then
            LastIsNotStandingIndex = 0
        Else
            LastIsNotStandingIndex += 1
        End If

        If AccX <> 0 Or AccY <> 0 Then
            HistoryQueueIndex = (HistoryQueueIndex + 1) Mod HistoryQueue.Count
            Tmp = HistoryQueue(HistoryQueueIndex)
            Tmp.MapX = Math.Truncate(Me.MapX)
            Tmp.MapY = Math.Truncate(Me.MapY)
            Tmp.IsStanding = Me.IsStanding
            Tmp.RenderStage = Me.RenderStage

        Else

            If LastIsNotStandingIndex < 110 Then
                HistoryQueueIndex = (HistoryQueueIndex + 1) Mod HistoryQueue.Count
                Tmp = HistoryQueue(HistoryQueueIndex)
                Tmp.MapX = Math.Truncate(Me.MapX)
                Tmp.MapY = Math.Truncate(Me.MapY)
                Tmp.IsStanding = Me.IsStanding
                Tmp.RenderStage = Me.RenderStage
            End If



        End If

    End Sub

    ' modify the render subroutine a little bit
    Public Overrides Sub RenderCreature()
        ' check to see if it is used
        If Not IsRendered Then
            Exit Sub
        End If

        ' check to see if the creature within the bounds of the display , if not no need to render
        If MapX < GameMapObject.ViewX1 Or MapX > GameMapObject.ViewX2 Or MapY < GameMapObject.ViewY1 Or MapY > GameMapObject.ViewY2 Then
            Exit Sub
        End If

        If Unaffected > 0 Then
            If Math.Round(Unaffected) Mod 2 = 0 Then
                Exit Sub
            End If
        End If



        ' check if axe need to be rendered
        If CurrentWeapon = Box.BoxContent.Axe AndAlso HasAxe AndAlso Not IsUsingAxe AndAlso ControlMode = CreatureControlModeEnum.ControlModePlayer Then
            Dim SP As AgateLib.Sprites.Sprite
            Dim XS As Integer
            If Direction = CreatueXDirection.LeftDirection Then
                SP = GameSpritesObject.AxeLeftSprite
                XS = 5
            Else
                SP = GameSpritesObject.AxeRightSprite
                XS = 10
            End If

            ' check to see if it is used
            If Not IsRendered Then
                Exit Sub
            End If

            ' check to see if the creature within the bounds of the display , if not no need to render
            If MapX < GameMapObject.ViewX1 Or MapX > GameMapObject.ViewX2 Or MapY < GameMapObject.ViewY1 Or MapY > GameMapObject.ViewY2 Then
                Exit Sub
            End If

            ' render the creature
            SP.Draw(Me.MapX - GameMapObject.ViewX1 + GameMapObject.ViewXShift - Me.HalfWidth - XS, Me.MapY - GameMapObject.ViewY1 + GameMapObject.ViewYShift - Me.CreatureHeight + SpriteYShift)

        End If


        If IsUsingAxe Then

            ' get the frame no
            Dim Diff As Long = (System.Environment.TickCount - IsUsingAxeTimeStamp) Mod 250
            Dim FRM As Integer = Diff \ 62
            Dim CF As Integer = 0
            If FRM = 0 Then CF = 0
            If FRM = 1 Then CF = 1
            If FRM = 2 Then CF = 2
            If FRM = 3 Then CF = 1

            If Me.Direction = CreatueXDirection.RightDirection Then
                CF = CF + 3
            End If

            HeroAxeSprite.CurrentFrameIndex = CF
            HeroAxeSprite.Draw(Me.MapX - GameMapObject.ViewX1 + GameMapObject.ViewXShift - Me.HalfWidth + SpriteXShift, Me.MapY - GameMapObject.ViewY1 + GameMapObject.ViewYShift - Me.CreatureHeight + SpriteYShift)

        Else
            ' render the creature
            CreatureSprites.CurrentFrameIndex = RenderStage
            CreatureSprites.Draw(Me.MapX - GameMapObject.ViewX1 + GameMapObject.ViewXShift - Me.HalfWidth + SpriteXShift, Me.MapY - GameMapObject.ViewY1 + GameMapObject.ViewYShift - Me.CreatureHeight + SpriteYShift)
        End If



    End Sub
End Class
