﻿' developed by mkaatr 2011
' http://www.mka-soft.com

Public Class Info                                                       ' this class is used to display some
    Inherits BaseCreature                                               ' text messaged to the player

    Public Message As String = "..."                                    ' set the default message
    Public MsgTimer As Long = 0                                         ' message timer effect
    Public RenderMsg As Boolean = True                                  ' the message should be rendered when this flag is true
    Private TextSurface As AgateLib.DisplayLib.FontSurface              ' used to redner the message
    Private MsgBoxWidth As Integer = 0                                  ' the width and heigh of the messagebox
    Private MsgBoxHeight As Integer = 0

    ' the constructor
    Public Sub New()
        IsAffactedByArrow = False
        IsAffactedByExplosion = False

        MsgTimer = System.Environment.TickCount                                         ' get system time
        If TextSurface Is Nothing Then TextSurface = New AgateLib.DisplayLib.FontSurface("Times", 10, FontStyle.Bold) ' generate the font surface
        CreatureType = CretureTypeEnum.CreatureType_Info                                ' type of creature
        HPEffect = 0                                                                    ' has no effect on the player
        IsRendered = True                                                               ' is rednered
        AccX = 0                                                                        ' other setting are similar to other creatures
        AccY = 0
        RenderStage = 0
        CreatureWidth = 16
        CreatureHeight = 16
        HalfWidth = CreatureWidth \ 2
        HalfHeight = CreatureHeight \ 2
        IsAffectedByGravity = False
        CanBounce = False
        Gravity = 0
        MaxGravity = 0
        SolidBlocks = New List(Of MapBlockType)
        StandOnBlocks = New List(Of MapBlockType)

        ' load the sprite
        CreatureSprites = GameSpritesObject.InfoSprite
        CreatureSprites.CurrentFrameIndex = 0

    End Sub

    
    ' rendering is modified 
    Public Overrides Sub RenderCreature()


        ' find the transperency 
        Dim Alpha As Double = 1 - ((System.Environment.TickCount Mod 1000) / 1000.0)

        ' check to see if it is a fade in or out
        If (System.Environment.TickCount) \ 1000 Mod 2 = 0 Then
            Alpha = 1 - Alpha
        End If


        ' check to see if it is rednered
        If Not IsRendered Then
            Exit Sub
        End If

        ' if the creature is outside the map, don't render
        If MapX < GameMapObject.ViewX1 Or MapX > GameMapObject.ViewX2 Or MapY < GameMapObject.ViewY1 Or MapY > GameMapObject.ViewY2 Then
            Exit Sub
        End If

        ' set render stage and alpha value
        CreatureSprites.CurrentFrameIndex = RenderStage
        CreatureSprites.Alpha = Alpha

        ' render the message
        If RenderMsg Then

            ' find the width of the message
            If MsgBoxWidth = 0 Then
                MsgBoxWidth = TextSurface.StringDisplayWidth(Me.Message) + 4
                MsgBoxHeight = TextSurface.StringDisplayHeight(Me.Message) + 4
            End If

            ' find where to place the message
            Dim DisplayX As Long = MapX - GameMapObject.ViewX1 + GameMapObject.ViewXShift - Me.HalfWidth + SpriteXShift - MsgBoxWidth \ 2
            Dim DisplayY As Long = MapY - GameMapObject.ViewY1 + GameMapObject.ViewYShift - Me.CreatureHeight + SpriteYShift - 32 - MsgBoxHeight

            ' draw the pop up msgbox
            AgateLib.DisplayLib.Display.DrawRect(DisplayX, DisplayY, MsgBoxWidth, MsgBoxHeight, AgateLib.Geometry.Color.White)
            AgateLib.DisplayLib.Display.FillRect(DisplayX + 1, DisplayY + 1, MsgBoxWidth - 1, MsgBoxHeight - 1, AgateLib.Geometry.Color.Black)

            ' set the transperency of the message and part to display
            Dim TF As Long = (System.Environment.TickCount - MsgTimer) \ 100
            If TF < Me.Message.Length Then
                TextSurface.Color = AgateLib.Geometry.Color.FromArgb(CDbl(TF) / Me.Message.Length * 255.0, 255, 255, 255)
                TextSurface.DrawText(DisplayX + 2, DisplayY + 2, Me.Message.Substring(0, TF))
            Else
                TextSurface.Color = AgateLib.Geometry.Color.FromArgb(255, 255, 255, 255)
                TextSurface.DrawText(DisplayX + 2, DisplayY + 2, Me.Message)
            End If

            ' if the character is touching the info box, then increase transperency
            CreatureSprites.Alpha = CreatureSprites.Alpha / 2.0

        End If

        ' render
        CreatureSprites.Draw(MapX - GameMapObject.ViewX1 + GameMapObject.ViewXShift - Me.HalfWidth + SpriteXShift, MapY - GameMapObject.ViewY1 + GameMapObject.ViewYShift - Me.CreatureHeight + SpriteYShift)
    End Sub

End Class
