﻿' developed by mkaatr 2011
' http://www.mka-soft.com

Public Class Smoke                                                  ' used to generate smoke effect
    Inherits BaseCreature


    Private TimeCounter As Long                                     ' a timer
    Private TmpX As Long = 0                                        ' used to set where the smoke appear
    Private TmpY As Long = 0


    Public Sub New()
        IsAffactedByArrow = False
        IsAffactedByExplosion = False

        CreatureType = CretureTypeEnum.CreatureType_Smoke
        HPEffect = 0
        IsRendered = True
        AccX = 0
        AccY = 0
        RenderStage = 0
        CreatureWidth = 16
        CreatureHeight = 16
        HalfWidth = CreatureWidth \ 2 - 0
        HalfHeight = CreatureHeight \ 2 - 0
        IsAffectedByGravity = False
        CanBounce = False
        Gravity = 0
        MaxGravity = 0
        SolidBlocks = New List(Of MapBlockType)
        StandOnBlocks = New List(Of MapBlockType)

        TimeCounter = System.Environment.TickCount


        ' load the dummy shapes
        CreatureSprites = GameSpritesObject.SmokeSprite
        CreatureSprites.CurrentFrameIndex = 0

    End Sub

    ' for future update
    Public Overrides Sub UpdateLocation(ByVal Info As Object, ByVal UserInput As GameInputClass)

        ' make sure nothing is being called here

    End Sub

    ' for future update
    Public Overrides Sub RenderCreature()

        ' each second the smoke should restart
        If (System.Environment.TickCount - TimeCounter) > 500 Then
            TmpX = MapX
            TmpY = MapY
            TimeCounter = System.Environment.TickCount - GameRandomNumberObject.Next(0, 100)
            AccX = 1 + GameRandomNumberObject.Next(0, 200) / 500.0
            If GameRandomNumberObject.Next(0, 100) > 50 Then
                AccX = -AccX
            End If
            AccY = -1 - GameRandomNumberObject.Next(0, 200) / 500.0
        End If

        ' update location of smoke
        If TmpX > MapX Then AccX = AccX - 0.1 * GameTimeObject.GameTimeDiff
        If TmpX <= MapX Then AccX = AccX + 0.1 * GameTimeObject.GameTimeDiff

        TmpX += GameTimeObject.GameTimeDiff * AccX
        TmpY += GameTimeObject.GameTimeDiff * AccY

        ' set transperency of the smoke
        Dim Alpha As Double = 1 - ((System.Environment.TickCount - TimeCounter) / 500.0)



        ' check to see if it is used
        If Not IsRendered Then
            Exit Sub
        End If

        ' if the smoke is out of the screen don't render it
        If MapX < GameMapObject.ViewX1 Or MapX > GameMapObject.ViewX2 Or MapY < GameMapObject.ViewY1 Or MapY > GameMapObject.ViewY2 Then
            Exit Sub
        End If

        ' render the smoke
        CreatureSprites.CurrentFrameIndex = RenderStage
        CreatureSprites.Alpha = Alpha
        CreatureSprites.Draw(TmpX - GameMapObject.ViewX1 + GameMapObject.ViewXShift - Me.HalfWidth + SpriteXShift, TmpY - GameMapObject.ViewY1 + GameMapObject.ViewYShift - Me.CreatureHeight + SpriteYShift)

    End Sub


End Class
