﻿' developed by mkaatr
Public Class BatEnemy
    Inherits BaseCreature

    Private Enum BatMode
        BatModeFly = 1
        BatModeHanging = 2
        BatModeGoingToHang = 3
    End Enum

    Dim R As Random
    Dim ModeCounter As Integer = 0                              ' a counter specifying for how long a bat flies
    Dim Mode As BatMode = BatMode.BatModeFly                    ' the side
    Dim RndTime As Long
    Dim RndTimeX2 As Long
    Dim FlyingStartTime As Long
    Dim HandingStartTime As Long
  
    ' the constrcutor
    Public Sub New()
        IsAffactedByArrow = True
        IsAffactedByExplosion = True

        CreatureType = CretureTypeEnum.CreatureType_BatEnemy         ' type of creature
        R = GameRandomNumberObject                               ' random number generator
        RndTime = 250 + R.Next(0, 50)                          ' this makes the bat wigs use different speed from others
        RndTimeX2 = RndTime * 2
        HPEffect = 10                                           ' the strength of bat attack
        IsRendered = True                                       ' rendered
        MapX = 50                                               ' x, and y
        MapY = 30
        AccY = (500 - R.Next(0, 1000)) / 500
        AccX = (500 - R.Next(0, 1000)) / 500

        SolidBlocks = New List(Of MapBlockType)
        StandOnBlocks = New List(Of MapBlockType)
        SolidBlocks.Add(MapBlockType.BrickBlock)          ' the bat can't go throw these
        SolidBlocks.Add(MapBlockType.RocksBlock)
        SolidBlocks.Add(MapBlockType.GrassBlock)
        SolidBlocks.Add(MapBlockType.WaterBlock)
        SolidBlocks.Add(MapBlockType.BreakableBrick)


        RenderStage = 0
        CreatureWidth = 16 * 3
        CreatureHeight = 16 * 2
        HalfWidth = CreatureWidth \ 2
        HalfHeight = CreatureHeight \ 2
        IsAffectedByGravity = False
        CanBounce = True
        Gravity = 0.1
        MaxGravity = 10
        CreatureSprites = GameSpritesObject.BatSprite
        CreatureSprites.CurrentFrameIndex = 1
        SpriteXShift = 0
        SpriteYShift = 0
        FlyingStartTime = System.Environment.TickCount
    End Sub

    ' update the location of the monkey, this needs some extra work
    Public Overrides Sub UpdateLocation(ByVal Info As Object, ByVal UserInput As GameInputClass)



        ' this part is used to select the correct frame.
        If Mode = BatMode.BatModeHanging Then
            Me.RenderStage = 2
        Else
            Me.RenderStage = (System.Environment.TickCount Mod RndTimeX2) \ RndTime
        End If



        ' this part calculate the fly situation
        If Mode = BatMode.BatModeFly Then

            ' if the bat is flying for more than 20 seconds, then change the mode
            If System.Environment.TickCount - Me.FlyingStartTime > 20000 Then

                Mode = BatMode.BatModeGoingToHang

            Else

                ' if not put some code here so that the bat attacks the user

            End If

        ElseIf Mode = BatMode.BatModeGoingToHang Then


            ' this mode means that the bat is searching for a place to hang itslef, firs try to find if a place exits
            Dim TP = IsHangingBrickAvailabe()
            If TP = 2 Then
                ' the bat should land now
                Mode = BatMode.BatModeHanging
                Me.HandingStartTime = System.Environment.TickCount
                MapY = (MapY \ 16 + 1) * 16
                AccX = 0
                AccY = 0
            ElseIf TP > 2 Then
                AccY = -0.3
                AccX = AccX / 1.1
            Else
                If System.Environment.TickCount - Me.FlyingStartTime > 5000 Then
                    AccY = (500 - R.Next(0, 1000)) / 500.0 * 1.5
                    AccX = (500 - R.Next(0, 1000)) / 500.0 * 1.5
                    If R.Next(1, 1000) >= 500 Then
                        If AccY < 0 Then AccY = -AccY
                    End If
                    Me.FlyingStartTime = System.Environment.TickCount
                End If
            End If

        ElseIf Mode = BatMode.BatModeHanging Then
            If System.Environment.TickCount - Me.HandingStartTime >= 15000 Then
                Mode = BatMode.BatModeFly
                AccY = (500 - R.Next(0, 1000)) / 500.0 * 1.5
                AccX = (500 - R.Next(0, 1000)) / 500.0 * 1.5
                Me.FlyingStartTime = System.Environment.TickCount
            End If
        End If



        ' update location now based on previous processing
        MyBase.UpdateLocation(Info, UserInput)
    End Sub


    ' this function will check and see if there is a brick the bat can hang to 
    Private Function IsHangingBrickAvailabe() As Integer
        Dim I As Integer
        For I = 0 To 16
            Dim TY As Integer = (MapY - I * 16) \ 16
            Dim TX As Long = MapX \ 16
            If TX >= 0 And TX < GameMapObject.GameMap.GetLength(0) And TY >= 0 And TY < GameMapObject.GameMap.GetLength(1) Then
                Dim J As Integer
                For J = 0 To SolidBlocks.Count - 1
                    If GameMapObject.GameMap(TX, TY) = SolidBlocks(J) Then
                        Return I
                    End If
                Next
            End If
        Next
        Return -1
    End Function
End Class
