﻿' developed by mkaatr 2011
' http://www.mka-soft.com

Public Class MonkeyEnemy                                        ' a jumping monkey
    Inherits BaseCreature
    Dim R As Random
    Dim SideCounter As Integer = 0                              ' a counter specifying for how long a monkey keeps moving on a specific side
    Dim Side As Integer                                         ' the side

    ' the constrcutor
    Public Sub New()
        IsAffactedByArrow = True
        IsAffactedByExplosion = True

        CreatureType = CretureTypeEnum.CreatureType_Monkey      ' type of creature
        R = GameRandomNumberObject                               ' random number generator
        HPEffect = 2                                            ' the strength of monkey attack
        IsRendered = True                                       ' rendered
        MapX = 50                                               ' x, and y
        MapY = 30
        AccY = 0

        SolidBlocks = New List(Of MapBlockType)
        StandOnBlocks = New List(Of MapBlockType)
        SolidBlocks.Add(MapBlockType.BrickBlock)          ' the monkey can stand on normal bricks
        SolidBlocks.Add(MapBlockType.RocksBlock)
        SolidBlocks.Add(MapBlockType.GrassBlock)
        SolidBlocks.Add(MapBlockType.BreakableBrick)

        StandOnBlocks.Add(MapBlockType.TreeBranches)            ' it can also stand on branches

        Direction = CreatueXDirection.RightDirection            ' first the monkey is looking to the right
        RenderStage = 0
        CreatureWidth = 25
        CreatureHeight = 26
        HalfWidth = CreatureWidth \ 2
        HalfHeight = CreatureHeight \ 2
        IsAffectedByGravity = True
        CanBounce = False
        Gravity = 0.1
        MaxGravity = 10
        CreatureSprites = GameSpritesObject.MonkeySprite
        CreatureSprites.CurrentFrameIndex = 1
        SpriteXShift = -4

    End Sub

    ' update the location of the monkey, this needs some extra work
    Public Overrides Sub UpdateLocation(ByVal Info As Object, ByVal UserInput As GameInputClass)


        ' check and make sure that the monkey is standing on a tile
        If IsStanding Then
            If R.Next(0, 1000) > 990 Then
                AccY = -5                       ' randomly make a decision to jump
            End If
        End If

        SideCounter = SideCounter - 1           ' update the side the monkey is moving towards
        If SideCounter <= 0 Then
            SideCounter = 500
            Side = R.Next(0, 10) Mod 2
        End If

        AccX = 0


        ' if the monkey is moving right
        If Side = 0 Then
            If Not IsStanding Then AccX = +2.5 Else AccX = 0
            Me.Direction = CreatueXDirection.RightDirection
        End If

        ' if the monkey is moving left
        If Side = 1 Then
            If Not IsStanding Then AccX = -2.5 Else AccX = 0
            Me.Direction = CreatueXDirection.LeftDirection
        End If


        ' this part is used to select the correct frame.
        ' check if the char is jumping
        If Not IsStanding Then
            If Direction = CreatueXDirection.LeftDirection Then
                Me.RenderStage = 2
            Else
                Me.RenderStage = 0
            End If
        Else
            If Direction = CreatueXDirection.LeftDirection Then
                Me.RenderStage = 3
            Else
                Me.RenderStage = 1
            End If
        End If


        ' update location now based on previous processing
        MyBase.UpdateLocation(Info, UserInput)
    End Sub

   
End Class
