﻿' developed by mkaatr 2011
Public Class SpiderEnemy
    Inherits BaseCreature

    Private BaseNetX As Integer = -1
    Private BaseNetY As Integer = -1
    Private NextNetX As Integer = -1
    Private NextNetY As Integer = -1
    Private Timer As Integer = -1
    Private DownOrUp As Integer = -1

    Public Sub New()
        IsAffactedByArrow = True
        IsAffactedByExplosion = True

        CreatureType = CretureTypeEnum.CreatureType_SpiderEnemy
        HPEffect = 10
        IsRendered = True
        MapX = 50
        MapY = 30
        AccY = 0
        SolidBlocks = New List(Of MapBlockType)
        StandOnBlocks = New List(Of MapBlockType)


        Direction = CreatueXDirection.RightDirection
        RenderStage = 0
        CreatureWidth = 40
        CreatureHeight = 34
        HalfWidth = CreatureWidth \ 2
        HalfHeight = CreatureHeight \ 2
        IsAffectedByGravity = False
        CanBounce = False

        CreatureSprites = GameSpritesObject.SpiderSprite
        CreatureSprites.CurrentFrameIndex = 1

    End Sub

    Public Overrides Sub UpdateLocation(ByVal Info As Object, ByVal UserInput As GameInputClass)
        If BaseNetX = -1 Then
            BaseNetX = MapX
            BaseNetY = MapY
            NextNetX = MapX
            NextNetY = MapY + 16 * 8
            DownOrUp = 0
            Timer = System.Environment.TickCount
        End If

        If DownOrUp = 0 Then ' this means the spider is waiting up, wait
            If System.Environment.TickCount - Timer + GeneralOperations.GameRandomNumberObject.Next(0, 1000) > 3000 Then
                DownOrUp = 1
                Timer = System.Environment.TickCount
                NextNetY = MapY + GameRandomNumberObject.Next(0, 16 * 8)

            End If
        ElseIf DownOrUp = 1 Then 'this means the spider should go down
            Dim TmpTimeDiff As Integer = GameTimeObject.GameTimeDiff
            If TmpTimeDiff > 1 Then
                TmpTimeDiff = 1
            End If
            MapY = MapY + 3 * TmpTimeDiff
            If MapY >= NextNetY Then
                DownOrUp = 2
                Timer = System.Environment.TickCount
            End If
        ElseIf DownOrUp = 2 Then ' this means the spider waits down
            If System.Environment.TickCount - Timer + GeneralOperations.GameRandomNumberObject.Next(0, 1000) > 3000 Then
                DownOrUp = 3
                Timer = System.Environment.TickCount
            End If
        ElseIf DownOrUp = 3 Then ' this means the spider is going up
            Dim TmpTimeDiff As Integer = GameTimeObject.GameTimeDiff
            If TmpTimeDiff > 1 Then
                TmpTimeDiff = 1
            End If
            MapY = MapY - 1 * TmpTimeDiff
            If MapY <= BaseNetY Then
                DownOrUp = 0
            End If
            Timer = System.Environment.TickCount
        End If

    End Sub

    Public Overrides Sub RenderCreature()

        ' check to see if it is used
        If Not IsRendered Then
            Exit Sub
        End If

        ' check to see if the creature within the bounds of the display , if not no need to render
        If MapX < GameMapObject.ViewX1 Or MapX > GameMapObject.ViewX2 Or MapY < GameMapObject.ViewY1 Or MapY > GameMapObject.ViewY2 Then
            Exit Sub
        End If

        ' draw spider's thread
        Dim XLOC As Long = Me.MapX - GameMapObject.ViewX1 + GameMapObject.ViewXShift - Me.HalfWidth + SpriteXShift
        Dim YLOC As Long = Me.MapY - GameMapObject.ViewY1 + GameMapObject.ViewYShift - Me.CreatureHeight + SpriteYShift

        Dim P1 As New AgateLib.Geometry.Point(XLOC + HalfWidth - 2, YLOC + HalfHeight)
        Dim P2 As New AgateLib.Geometry.Point(XLOC + HalfWidth - 2, BaseNetY - GameMapObject.ViewY1 + GameMapObject.ViewYShift - 20)
        AgateLib.DisplayLib.Display.DrawLine(P1, P2, AgateLib.Geometry.Color.FromArgb(200, 255, 255, 255))


        ' render the creature
        CreatureSprites.CurrentFrameIndex = RenderStage
        CreatureSprites.Draw(XLOC, YLOC)

    End Sub
End Class
