﻿Public Class StupidEnemy
    Inherits BaseCreature
    Dim R As Random = GameRandomNumberObject
    Dim SideCounter As Integer
    Dim Side As Integer


    Public Sub New()
        IsAffactedByArrow = True
        IsAffactedByExplosion = True

        CreatureType = CretureTypeEnum.CreatureType_StupidEnemy
        HPEffect = 10
        IsRendered = True
        MapX = 50
        MapY = 30
        AccY = 0
        SolidBlocks = New List(Of MapBlockType)
        SolidBlocks.Add(MapBlockType.BrickBlock)
        SolidBlocks.Add(MapBlockType.RocksBlock)
        SolidBlocks.Add(MapBlockType.GrassBlock)
        SolidBlocks.Add(MapBlockType.BreakableBrick)

        StandOnBlocks = New List(Of MapBlockType)

        Direction = CreatueXDirection.RightDirection
        RenderStage = 0
        CreatureWidth = 22
        CreatureHeight = 32
        HalfWidth = CreatureWidth \ 2 - 0
        HalfHeight = CreatureHeight \ 2 - 0
        IsAffectedByGravity = True
        CanBounce = False
        Gravity = 0.1
        MaxGravity = 10
        CreatureSprites = GameSpritesObject.StupidEnemySprite
        CreatureSprites.CurrentFrameIndex = 1

    End Sub

    Public Overrides Sub UpdateLocation(ByVal Info As Object, ByVal UserInput As GameInputClass)


        ' check and make sure that the person is standing on a brick
        If IsStanding Then
            If R.Next(0, 1000) > 990 Then
                AccY = -3.1
            End If
        End If

        SideCounter = SideCounter - 1
        If SideCounter <= 0 Then
            SideCounter = 300
            Side = R.Next(0, 10) Mod 2
        End If

        AccX = 0


        ' the the right button is presses
        If Side = 0 Then
            AccX = +2
            Me.Direction = CreatueXDirection.RightDirection
        End If

        ' the the left button is presses
        If Side = 1 Then
            AccX = -2
            Me.Direction = CreatueXDirection.LeftDirection
        End If


        ' this part is used to select the correct frame.
        ' check if the char is jumping
        If Not IsStanding Then
            If Direction = CreatueXDirection.LeftDirection Then
                Me.RenderStage = 7
            Else
                Me.RenderStage = 3
            End If
        ElseIf AccX <> 0 Then
            Dim STG As Integer = (MapX \ 10) Mod 4
            If STG = 0 Then Me.RenderStage = 2 + 0
            If STG = 1 Then Me.RenderStage = 0 + 0
            If STG = 2 Then Me.RenderStage = 2 + 0
            If STG = 3 Then Me.RenderStage = 1 + 0
            If Direction = CreatueXDirection.LeftDirection Then
                Me.RenderStage += 4
            End If
        Else
            If Direction = CreatueXDirection.LeftDirection Then
                Me.RenderStage = 6
            Else
                Me.RenderStage = 2
            End If
        End If



        MyBase.UpdateLocation(Info, UserInput)
    End Sub

End Class
