﻿Public Class GameCreaturesClass

    ' the character and enemy
    Public UserCharacter1 As Hero
    Public UserCharacter2 As Heroine
    Public AllCreatureList As List(Of BaseCreature)

    Public BoxList As List(Of Box)
    Public DynamiteAndBombList As List(Of BaseCreature)
    Public ArrowList As List(Of Arrow)
    Public EnemyList As List(Of BaseCreature)
    Public GateList As List(Of BaseCreature)
    Public ButtonList As List(Of BaseCreature)
    Public InfoList As List(Of BaseCreature)
    Public ActionList As List(Of BaseCreature)
    Public ArrowSourceList As List(Of BaseCreature)
    Public EffectsList As List(Of BaseCreature)

    ' set main characters
    Public Sub New()
        Me.UserCharacter1 = New Hero
        Me.AllCreatureList = New List(Of BaseCreature)
        Me.BoxList = New List(Of Box)
        Me.DynamiteAndBombList = New List(Of BaseCreature)
        Me.ArrowList = New List(Of Arrow)
        Me.EnemyList = New List(Of BaseCreature)
        Me.GateList = New List(Of BaseCreature)
        Me.ButtonList = New List(Of BaseCreature)
        Me.InfoList = New List(Of BaseCreature)
        Me.ActionList = New List(Of BaseCreature)
        Me.ArrowSourceList = New List(Of BaseCreature)
        Me.EffectsList = New List(Of BaseCreature)
    End Sub

    ' this function is used to categorise the list of creatures for fast processing
    Public Sub FillListsWithCorrectTypeOfCreature()

        For Each Itm In AllCreatureList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_Action Then
                ActionList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_ArrowButton Then
                ButtonList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_ArrowSource Then
                ArrowSourceList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_BatEnemy Then
                EnemyList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_Box Then
                BoxList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_Gate Then
                GateList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_Gate2 Then
                GateList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_Hero Then
                ' nothing
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_Heroine Then
                ' nothing
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_Info Then
                InfoList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_Monkey Then
                EnemyList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_OnOffButton Then
                ButtonList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_PresistantEnemy Then
                EnemyList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_PushButton Then
                ButtonList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_Smoke Then
                EffectsList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_SpiderEnemy Then
                EnemyList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_StupidEnemy Then
                EnemyList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_Teleport Then
                GateList.Add(Itm)
            ElseIf Itm.CreatureType = CretureTypeEnum.CreatureType_WolfmanEnemy Then
                EnemyList.Add(Itm)
            Else
                MsgBox(Itm.CreatureType)
            End If

        Next


        ' next update the gates to affact for each on off button
        For Each Item In ButtonList
            If Item.CreatureType = CretureTypeEnum.CreatureType_OnOffButton Then
                Dim T As OnOffButton = Item
                For Each Item2 In GateList
                    If Item2.CreatureType = CretureTypeEnum.CreatureType_Gate Then
                        Dim T2 As Gate = Item2
                        If T.ObjectToAffact = T2.ObjectName Then
                            T.GatesToAffact.Add(T2)
                        End If
                    End If
                Next
            End If
        Next

        ' next update the gates to affact for each push button
        For Each Item In ButtonList
            If Item.CreatureType = CretureTypeEnum.CreatureType_PushButton Then
                Dim T As PushButton = Item
                For Each Item2 In GateList
                    If Item2.CreatureType = CretureTypeEnum.CreatureType_Gate2 Then
                        Dim T2 As Gate2 = Item2
                        If T.ObjectToAffact = T2.ObjectName Then
                            T.GatesToAffact.Add(T2)
                        End If
                    End If
                Next
            End If
        Next

        ' next store all push buttons having the same name
        For Each Item In ButtonList
            If Item.CreatureType = CretureTypeEnum.CreatureType_PushButton Then
                Dim T As PushButton = Item
                For Each Item2 In ButtonList
                    If Item2.CreatureType = CretureTypeEnum.CreatureType_PushButton Then
                        Dim T2 As PushButton = Item2
                        If T.ObjectToAffact = T2.ObjectToAffact Then
                            T.ButtonsToAffact.Add(T2)
                        End If
                    End If
                Next
            End If
        Next

        ' next store all arrow sources
        For Each Item In ButtonList
            If Item.CreatureType = CretureTypeEnum.CreatureType_ArrowButton Then
                Dim T As ArrowButton = Item
                For Each Item2 In ArrowSourceList
                    If Item2.CreatureType = CretureTypeEnum.CreatureType_ArrowSource Then
                        Dim T2 As ArrowSource = Item2
                        If T.ObjectToAffact = T2.ObjectName Then
                            T.ArrowSources.Add(T2)
                        End If
                    End If
                Next
            End If
        Next

    End Sub

    ' update box list 
    Public Sub UpdateAllBoxes(ByVal Info As Object, ByVal CreatureControlInput As GameInputClass)
        For Each Itm In BoxList
            If Itm.IsRendered Then
                Itm.UpdateLocation(Info, CreatureControlInput)
            End If
        Next
    End Sub

    ' used to update dynamite abox bomblist
    Public Sub UpdateAllDynamiteAndBomb(ByVal Info As Object, ByVal CreatureControlInput As GameInputClass)
        For Each Itm In DynamiteAndBombList
            If Itm.IsRendered Then
                Itm.UpdateLocation(Info, CreatureControlInput)
            End If
        Next
    End Sub

    ' used to update dynamite arrow list
    Public Sub UpdateAllArrows(ByVal Info As Object, ByVal CreatureControlInput As GameInputClass)
        For Each Itm In ArrowList
            If Itm.IsRendered Then
                Itm.UpdateLocation(Info, CreatureControlInput)
            End If
        Next
    End Sub

    ' update all
    Public Sub UpdateAllCreatures(ByVal Info As Object, ByVal CreatureControlInput As GameInputClass)
        For Each Itm In AllCreatureList
            If Itm.IsRendered Then
                Itm.UpdateLocation(Info, CreatureControlInput)
            End If
        Next
    End Sub

    ' update enemy list
    Public Sub UpdateAllEnemies(ByVal Info As Object, ByVal CreatureControlInput As GameInputClass)
        For Each Itm In EnemyList
            If Itm.IsRendered Then
                Itm.UpdateLocation(Info, CreatureControlInput)
            End If
        Next
    End Sub

    ' update arrow sources
    Public Sub UpdateAllArrowSources(ByVal Info As Object, ByVal CreatureControlInput As GameInputClass)
        For Each Itm In ArrowSourceList
            If Itm.IsRendered Then
                Itm.UpdateLocation(Info, CreatureControlInput)
            End If
        Next
    End Sub

    ' update effects
    Public Sub UpdateAllEffects(ByVal Info As Object, ByVal CreatureControlInput As GameInputClass)
        For Each Itm In EffectsList
            If Itm.IsRendered Then
                Itm.UpdateLocation(Info, CreatureControlInput)
            End If
        Next
    End Sub

    ' update character location
    Public Sub UpdateUserCharacterLocation(ByVal CreatureControlInput As GameInputClass, ByVal UpdateHero As Boolean, ByVal UpdateHeroine As Boolean)
        If UpdateHero AndAlso UserCharacter1 IsNot Nothing Then
            UserCharacter1.UpdateLocation(UserCharacter2, CreatureControlInput)
        End If
        If UpdateHeroine AndAlso UserCharacter2 IsNot Nothing Then
            UserCharacter2.UpdateLocation(UserCharacter1, CreatureControlInput)
        End If
    End Sub

    ' update the buttons
    Public Sub UpdateAllButtons(ByVal Info As Object, ByVal CreatureControlInput As GameInputClass)
        For Each Itm In ButtonList
            Itm.UpdateLocation(Info, Nothing)
        Next
    End Sub

    ' update the gates
    Public Sub UpdateAllGates(ByVal Info As Object, ByVal CreatureControlInput As GameInputClass)
        For Each Itm In GateList
            Itm.UpdateLocation(Info, Nothing)
        Next
    End Sub

    ' render hero
    Public Sub RenderHero()
        UserCharacter1.RenderCreature()
    End Sub

    ' render heroine
    Public Sub RenderHeroine()
        UserCharacter2.RenderCreature()
    End Sub

    ' render enemies
    Public Sub RenderEnemies()
        For Each Itm In AllCreatureList
            Itm.RenderCreature()
        Next
    End Sub

    ' clear all
    Public Sub ClearAll()
        UserCharacter1 = Nothing
        UserCharacter2 = Nothing
        AllCreatureList.Clear()
        BoxList.Clear()
        DynamiteAndBombList.Clear()
        ArrowList.Clear()
        EnemyList.Clear()
        GateList.Clear()
        ArrowSourceList.Clear()
        ButtonList.Clear()
        InfoList.Clear()
        ActionList.Clear()
        EffectsList.Clear()
    End Sub

    ' remove enemies at location xy
    Public Sub RemoveObjectsAtLocationXY(ByVal X As Long, ByVal Y As Long)
        Dim I As Integer
        For I = Me.AllCreatureList.Count - 1 To 0 Step -1
            If Me.AllCreatureList(I).MapX = X And Me.AllCreatureList(I).MapY = Y Then
                Me.AllCreatureList.RemoveAt(I)
            End If
        Next
        For I = Me.BoxList.Count - 1 To 0 Step -1
            If Me.BoxList(I).MapX = X And Me.BoxList(I).MapY = Y Then
                Me.BoxList.RemoveAt(I)
            End If
        Next
    End Sub

    ' this function gets a teleport by name
    Public Function GetTeleportByName(ByVal TeleportName As String) As Teleport
        For Each Itm In GateList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_Teleport Then
                Dim Tmp As Teleport
                Tmp = Itm
                If Tmp.ObjectName = TeleportName Then
                    Return Tmp
                End If
            End If
        Next
        Return Nothing
    End Function

    ' this function is used to get the teleport colliding with creature
    Public Function GetTeleportCollidingWithCreature(ByVal pCreature As BaseCreature) As Teleport
        For Each Itm In GateList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_Teleport Then
                If pCreature.DoesObjectCollideWithCreature(Itm.MapX, Itm.MapY, Itm.CreatureWidth, Itm.CreatureHeight) Then
                    Return Itm
                End If
            End If
        Next
        Return Nothing
    End Function

    ' get gate 1 colliding with creature
    Public Function GetGate1CollidingWithCreature(ByVal pCreature As BaseCreature) As Gate
        For Each Itm In GateList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_Gate Then
                If pCreature.DoesObjectCollideWithCreature(Itm.MapX, Itm.MapY, Itm.CreatureWidth, Itm.CreatureHeight) Then
                    Return Itm
                End If
            End If
        Next
        Return Nothing
    End Function

    ' get gate 2 colliding with creature
    Public Function GetGate2CollidingWithCreature(ByVal pCreature As BaseCreature) As Gate2
        For Each Itm In GateList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_Gate2 Then
                If pCreature.DoesObjectCollideWithCreature(Itm.MapX, Itm.MapY, Itm.CreatureWidth, Itm.CreatureHeight) Then
                    Return Itm
                End If
            End If
        Next
        Return Nothing
    End Function

    ' get object colliding with on off button
    Public Function GetOnOffButtonCollidingWithCreature(ByVal pCreature As BaseCreature) As OnOffButton
        For Each Itm In ButtonList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_OnOffButton Then
                If pCreature.DoesObjectCollideWithCreature(Itm.MapX, Itm.MapY, Itm.CreatureWidth, Itm.CreatureHeight) Then
                    Return Itm
                End If
            End If
        Next
        Return Nothing
    End Function

    ' get push botton colliding with creature
    Public Function GetPushButtonCollidingWithCreature(ByVal pCreature As BaseCreature) As PushButton
        For Each Itm In ButtonList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_PushButton Then
                If pCreature.DoesObjectCollideWithCreature(Itm.MapX, Itm.MapY, Itm.CreatureWidth, Itm.CreatureHeight) Then
                    Return Itm
                End If
            End If
        Next
        Return Nothing
    End Function

    ' get arrow botton colliding with creature
    Public Function GetArrowButtonCollidingWithCreature(ByVal pCreature As BaseCreature) As ArrowButton
        For Each Itm In ButtonList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_ArrowButton Then
                If pCreature.DoesObjectCollideWithCreature(Itm.MapX, Itm.MapY, Itm.CreatureWidth, Itm.CreatureHeight) Then
                    Return Itm
                End If
            End If
        Next
        Return Nothing
    End Function

    ' get gat 1 by name
    Public Function GetGate1ByName(ByVal pName As String) As Gate
        For Each Itm In GateList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_Gate Then
                Dim Tmp As Gate = Itm
                If Tmp.ObjectName = pName Then
                    Return Tmp
                End If
            End If
        Next
        Return Nothing
    End Function

    ' get gat 2 by name
    Public Function GetGate2ByName(ByVal pName As String) As Gate2
        For Each Itm In GateList
            If Itm.CreatureType = CretureTypeEnum.CreatureType_Gate2 Then
                Dim Tmp2 As Gate2 = Itm
                If Tmp2.ObjectName = pName Then
                    Return Tmp2
                End If
            End If
        Next
        Return Nothing
    End Function

End Class
