﻿' developed by mkaatr, site: http://www.mka-soft.com

Public Class GameStatusClass

    Public BlackBox As AgateLib.DisplayLib.Surface
    Public TextSurface As AgateLib.DisplayLib.FontSurface
    Public Shoe As AgateLib.DisplayLib.Surface
    Public Dynamite As AgateLib.DisplayLib.Surface
    Public BouncingBomb As AgateLib.DisplayLib.Surface
    Public Glove As AgateLib.DisplayLib.Surface
    Public HeroIcon As AgateLib.DisplayLib.Surface
    Public HeroineIcon As AgateLib.DisplayLib.Surface
    Public AxeIcon As AgateLib.DisplayLib.Surface

    Public Sub RenderStatus(ByVal YourChar As Hero)
        Dim X As Integer = 0

        ' clear the top bar
        If BlackBox Is Nothing Then
            BlackBox = New AgateLib.DisplayLib.Surface(Application.StartupPath & "\images\black.bmp")
            Shoe = New AgateLib.DisplayLib.Surface(Application.StartupPath & "\images\shoe.png")
            TextSurface = New AgateLib.DisplayLib.FontSurface("Times", 10, FontStyle.Bold)
            Dynamite = New AgateLib.DisplayLib.Surface(Application.StartupPath & "\images\dynamite.png")
            BouncingBomb = New AgateLib.DisplayLib.Surface(Application.StartupPath & "\images\bomb.png")
            Glove = New AgateLib.DisplayLib.Surface(Application.StartupPath & "\images\glove.png")
            HeroIcon = New AgateLib.DisplayLib.Surface(Application.StartupPath & "\images\heroicon.png")
            HeroineIcon = New AgateLib.DisplayLib.Surface(Application.StartupPath & "\images\heroineicon.png")
            AxeIcon = New AgateLib.DisplayLib.Surface(Application.StartupPath & "\images\axeicon.png")
        End If

        ' next loop on top part
        Dim I As Integer
        Dim J As Integer
        For I = 0 To GameDisplayObject.MyDisplayWidth \ BlackBox.SurfaceWidth + 1
            For J = 0 To 70 \ BlackBox.SurfaceHeight + 1
                BlackBox.Draw(I * BlackBox.SurfaceWidth, J * BlackBox.SurfaceHeight)
            Next
        Next

        ' next draw the HP 
        Dim V As Integer = (YourChar.CurrentHP * 1.0) / YourChar.MaxHP * 100
        AgateLib.DisplayLib.Display.DrawRect(10, 20, 101, 11, AgateLib.Geometry.Color.White)
        AgateLib.DisplayLib.Display.FillRect(11, 21, V, 10, AgateLib.Geometry.Color.Red)
        TextSurface.DrawText(10, 0, "HP")

        ' next draw the Air
        If YourChar.Air < 30000 Then
            Dim VV As Integer = ((YourChar.Air * 1.0) / 30000.0) * 100
            AgateLib.DisplayLib.Display.DrawRect(120 + 10, 20, 101, 11, AgateLib.Geometry.Color.White)
            AgateLib.DisplayLib.Display.FillRect(120 + 11, 21, VV, 10, AgateLib.Geometry.Color.FromArgb(255, 100, 100, 255))
            TextSurface.DrawText(120 + 10, 0, "Air")
        End If

        ' check the shoe
        If YourChar.HasShoe Then
            Shoe.Draw(10 + X * 40, 40)
            X = X + 1
        End If

        ' check the dynmite sticks 
        If YourChar.DynamiteCount > 0 Then
            If YourChar.CurrentWeapon = Box.BoxContent.Dynamite Then
                Dynamite.Alpha = 1
            Else
                Dynamite.Alpha = 0.5
            End If
            Dynamite.Draw(10 + X * 40, 40)
            TextSurface.DrawText(10 + X * 40 + 10, 70, YourChar.DynamiteCount.ToString)
            X = X + 1
        End If

        ' check the bouncing bombs
        If YourChar.BouncingBombCount > 0 Then
            If YourChar.CurrentWeapon = Box.BoxContent.BounceingBomb Then
                BouncingBomb.Alpha = 1
            Else
                BouncingBomb.Alpha = 0.5
            End If
            BouncingBomb.Draw(10 + X * 40, 40)
            TextSurface.DrawText(10 + X * 40 + 10, 70, YourChar.BouncingBombCount.ToString)
            X = X + 1
        End If

        ' check has glove
        If YourChar.HasGlove Then
            Glove.Draw(10 + X * 40, 40)
            X = X + 1
        End If

        ' check if you should draw the current hero and heroine
        If YourChar.CanSwitchWithOtherPlayer Then
            If YourChar.CreatureType = CretureTypeEnum.CreatureType_Hero Then
                HeroIcon.Alpha = 1
                HeroineIcon.Alpha = 0.5
            Else
                HeroIcon.Alpha = 0.5
                HeroineIcon.Alpha = 1
            End If
            HeroineIcon.Draw(10 + X * 40, 40)
            X = X + 1
            HeroIcon.Draw(10 + X * 40, 40)
            X = X + 1
        End If


        ' check has glove
        If YourChar.hasAxe Then
            If YourChar.CurrentWeapon = Box.BoxContent.Axe Then
                AxeIcon.Alpha = 1
                AxeIcon.Draw(10 + X * 40, 40)
                X = X + 1
            Else
                AxeIcon.Alpha = 0.5
                AxeIcon.Draw(10 + X * 40, 40)
                X = X + 1
            End If
        End If

    End Sub

End Class
