﻿' developed by mkaatr, check the website: http://www.mka-soft.com
' this game uses Agatelib game engine. Check it out at: http://www.agatelib.org/
' this is a free game, currently under developement
' run this code at your own risk.

Public Module GeneralOperations

    ' define game global objects
    Public GameSoundsObject As GameSoundsClass
    Public GameInputObject As GameInputClass
    Public GameSpritesObject As GameSpritesClass
    Public GameRandomNumberObject As New Random
    Public GameDisplayObject As GameDisplayClass
    Public GameMapObject As GameMapClass
    Public GameStatusObject As GameStatusClass
    Public GameTextSufaceObject As AgateLib.DisplayLib.FontSurface
    Public GameTimeObject As GameTimeClass
    Public GameCreaturesObject As GameCreaturesClass

    ' set game global object
    Public Function InitializeGlobalGameObjects(ByVal FullScreenMode As Boolean, ByVal Width As Integer, ByVal Height As Integer) As Boolean

        ' game display
        If GameDisplayObject Is Nothing Then
            GameDisplayObject = New GameDisplayClass
        End If

        If Not GameDisplayObject.InitGameWindow(FullScreenMode, Width, Height) Then
            Return False
        End If


        ' game input
        If GameInputObject Is Nothing Then
            GameInputObject = New GameInputClass
        End If

        ' game sprites
        If GameSpritesObject Is Nothing Then
            GameSpritesObject = New GameSpritesClass
            If Not GameSpritesObject.LoadAllSprites() Then
                Return False
            End If
        End If

        ' game sound
        If GameSoundsObject Is Nothing Then
            GameSoundsObject = New GameSoundsClass
            If Not GameSoundsObject.LoadAllSoundsToMemory() Then
                Return False
            End If
        End If


        ' game map
        If GameMapObject Is Nothing Then
            GameMapObject = New GameMapClass
        End If

        ' game status
        If GameStatusObject Is Nothing Then
            GameStatusObject = New GameStatusClass
        End If

        ' font surfce 
        If GameTextSufaceObject Is Nothing Then
            GameTextSufaceObject = New AgateLib.DisplayLib.FontSurface("Times", 10, FontStyle.Bold)
        End If

        ' game time
        If GameTimeObject Is Nothing Then
            GameTimeObject = New GameTimeClass
        End If

        ' game creatures
        If GameCreaturesObject Is Nothing Then
            GameCreaturesObject = New GameCreaturesClass
        End If

        Return True

    End Function


    ' define the agatelib object
    Dim Setup As AgateLib.AgateSetup

    ' perform the setup or ini operation
    Public Function InitializeAgateLib() As Boolean
        Setup = New AgateLib.AgateSetup()
        Setup.InitializeAll()
        If Setup.WasCanceled Then
            Return False
        Else
            Return True
        End If
    End Function




    ' render the main screen
    Public Function RenderWelcomeScreen() As String

        Do

            ' Size 30 text surface
            Dim Size30TextObject As New AgateLib.DisplayLib.FontSurface("Times", 30, AgateLib.DisplayLib.FontStyle.Bold)


            ' the character x,y
            Dim X As Double = 1
            Dim Y As Double = 1


            ' <<****************************************************************************

           
            ' set the view x location
            GameDisplayObject.EyeX = 0


            ' set the timers
            GameTimeObject.UpdateGameTime()

            ' >>*****************************************************************************


            ' load the main welcome page map, and make sure its going to fit the screen
            GameMapObject.LoadMap(Application.StartupPath & "\opening.map", False)

            ' set the main character parameters to show it as a demo
            GameCreaturesObject.UserCharacter1.ControlMode = CreatureControlModeEnum.ControlModeFriendAI
            GameCreaturesObject.UserCharacter1.IsInDemoMode = True
            GameCreaturesObject.UserCharacter1.Unaffected = 0

            ' get the middle of the screen
            Dim TargetPoint As Integer = GameMapObject.GameMapActualWidth / 2


            If GameMapObject.GameMapActualWidth < GameDisplayObject.MyDisplayWidth Then
                Dim AddedCells As Integer = (GameDisplayObject.MyDisplayWidth - GameMapObject.GameMapActualWidth) \ 16 + 20
                Dim OldWidth As Integer = GameMapObject.GameMapWidthDiv16
                Dim OldHeight As Integer = GameMapObject.GameMapHeightDiv16


                Dim XI As Integer
                Dim XJ As Integer
                Dim Tmp(0 To OldWidth + AddedCells, 0 To OldHeight + AddedCells) As MapBlockType
                For XI = 0 To Tmp.GetLength(0) - 1
                    For XJ = Tmp.GetLength(1) - 1 To Tmp.GetLength(1) - 30 Step -1
                        Tmp(XI, XJ - 1) = MapBlockType.Grass
                        Tmp(XI, XJ) = MapBlockType.GrassBlock
                    Next
                Next
                For XI = 0 To 8
                    For XJ = Tmp.GetLength(1) - 1 To 0 Step -1
                        Tmp(XI, XJ) = MapBlockType.GrassBlock
                        Tmp(Tmp.GetLength(0) - 1 - XI, XJ) = MapBlockType.GrassBlock
                    Next
                Next
                For XI = 0 To GameMapObject.GameMapWidthDiv16 - 1
                    For XJ = 0 To GameMapObject.GameMapHeightDiv16 - 1
                        Tmp(XI + AddedCells \ 2, XJ + AddedCells \ 2) = GameMapObject.GameMap(XI, XJ)
                    Next
                Next

                GameMapObject.GameMap = Tmp
                GameMapObject.GameMapActualWidth = Tmp.GetLength(0) * 16
                GameMapObject.GameMapActualHeight = Tmp.GetLength(1) * 16
                GameMapObject.GameMapWidthDiv16 = Tmp.GetLength(0)
                GameMapObject.GameMapHeightDiv16 = Tmp.GetLength(1)
            End If



            ' prepare some map view variables
            Dim TmpWidth = GameDisplayObject.MyDisplayWidth
            Dim TmpHeight = GameDisplayObject.MyDisplayHeight
            GameDisplayObject.MidDisplayX = GameDisplayObject.MyDisplayWidth / 2
            GameDisplayObject.MidDisplayY = GameDisplayObject.MyDisplayHeight / 2

            ' check to see if the whole map fits in the display
            If GameMapObject.GameMapActualWidth < TmpWidth Then TmpWidth = GameMapObject.GameMapActualWidth
            If GameMapObject.GameMapActualHeight < TmpHeight Then TmpHeight = GameMapObject.GameMapActualHeight


            ' load all possible map names
            Dim MapNameList As New List(Of String)
            Dim FileList = System.IO.Directory.GetFiles(Application.StartupPath & "\maps")
            For Each FN In FileList
                If FN.EndsWith(".map") Then MapNameList.Add(System.IO.Path.GetFileName(FN))
            Next

            Dim SelectedMapIndex As Integer = 0

            ' place the character at the center
            GameCreaturesObject.UserCharacter1.MapX = GameMapObject.GameMapActualWidth \ 2
            GameCreaturesObject.UserCharacter1.MapY = (GameMapObject.GameMapActualHeight \ 3) * 2


            ' the main rendering loop
            Do While Not GameDisplayObject.GameWindow.IsClosed


                ' update the time 
                GameTimeObject.UpdateGameTime()


                ' begin rendering
                AgateLib.DisplayLib.Display.BeginFrame()

                ' prepare the display by clearing it
                AgateLib.DisplayLib.Display.Clear(255, 51, 153, 204)

                ' <<**************************************************************************
                ' update the location of this creature
                GameCreaturesObject.UpdateUserCharacterLocation(GameInputObject, True, False)


                ' update enemy location
                GameCreaturesObject.UpdateAllCreatures(GameCreaturesObject.UserCharacter1, Nothing)


                ' update the motion of the character
                If GameCreaturesObject.UserCharacter1.MapX < TargetPoint Then GameCreaturesObject.UserCharacter1.AccX = 1.2
                If GameCreaturesObject.UserCharacter1.MapX > TargetPoint Then GameCreaturesObject.UserCharacter1.AccX = -1.2

                ' update the target point to a new one if the user character is too near.
                If Math.Abs(GameCreaturesObject.UserCharacter1.MapX - TargetPoint) < 10 Then
                    TargetPoint = GameRandomNumberObject.Next(0, 400) + (GameMapObject.GameMapActualWidth / 2 - 200)
                End If

                ' make the character jump
                If GameCreaturesObject.UserCharacter1.IsStanding AndAlso GameRandomNumberObject.Next(0, 1000) > 985 Then
                    GameCreaturesObject.UserCharacter1.AccY = -3.5
                End If



                GameDisplayObject.EyeX = GameCreaturesObject.UserCharacter1.MapX
                GameDisplayObject.EyeY = GameCreaturesObject.UserCharacter1.MapY - 15 * 16
                ' >>****************************************************************************


                ' render the map
                GameMapObject.RenderMap(False)

                ' <<*****************************************************************************
                ' render the character
                GameCreaturesObject.RenderHero()

                ' render enemies
                GameCreaturesObject.RenderEnemies()

                ' >>***************************************************************************


                ' render water
                GameMapObject.RenderWaterAndStreetLampInMap()



                ' render the name of game
                Size30TextObject.Color = AgateLib.Geometry.Color.FromArgb(100, 100, 100 + (System.Environment.TickCount \ 100) Mod 150)
                Size30TextObject.DrawText(100, 10, "The Escape")


                ' render main menu options
                Dim LOCMid = GameDisplayObject.MyDisplayWidth / 2 - 380

                AgateLib.DisplayLib.Display.FillRect(LOCMid, 100, 300, 270, AgateLib.Geometry.Color.FromArgb(128, 0, 0, 0))
                GameTextSufaceObject.Color = AgateLib.Geometry.Color.White
                Dim LN As Integer = 0
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Press [1] to start an advanture") : LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Press [2] or [enter] to select a map to play") : LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Press [ESC] to exit") : LN += 1

                LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Player controls") : LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Use arrow keys to move your character") : LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Use [1] to select dynamite as a weapon") : LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Use [2] to select bouncing bombs as a weapon") : LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Use [3] to transfer control to the heroine") : LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Use [4] to transfer control to the hero") : LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Use [5] to instruct the heroine to follow you") : LN += 1
                GameTextSufaceObject.DrawText(LOCMid + 10, LN * 20 + 110, "Use [space] use the weapon") : LN += 1


                ' next render possible maps 
                AgateLib.DisplayLib.Display.FillRect(LOCMid + 370, 100, 400, 450, AgateLib.Geometry.Color.FromArgb(128, 0, 0, 0))
                LN = 0
                GameTextSufaceObject.DrawText(LOCMid + 380, LN * 20 + 110, "Available Maps:") : LN += 1
                LN += 1
                For Each Itm In MapNameList
                    GameTextSufaceObject.DrawText(LOCMid + 380, LN * 20 + 110, Itm) : LN += 1
                Next

                ' update user controls
                GameInputObject.UpdateControlInputStatusFromKeyboard()

                If MapNameList.Count <> 0 Then

                    ' make sure at least the first map is chosen
                    If SelectedMapIndex = -1 Then
                        SelectedMapIndex = 0
                    End If

                    ' render a rectangle around the player selection
                    AgateLib.DisplayLib.Display.DrawRect(LOCMid + 375, 20 * (SelectedMapIndex + 2) + 110 + 2, 380, 20 - 5, AgateLib.Geometry.Color.FromArgb(100 + (System.Environment.TickCount / 20) Mod 155, 0, 0))


                    ' check if the up arrow button is slected
                    If GameInputObject.IsUp And Not GameInputObject.OldUp Then
                        SelectedMapIndex = SelectedMapIndex - 1
                        If SelectedMapIndex < 0 Then
                            SelectedMapIndex = 0
                        End If
                    End If

                    ' check if the down arrow button is selected
                    If GameInputObject.IsDown And Not GameInputObject.OldDown Then
                        SelectedMapIndex = SelectedMapIndex + 1
                        If SelectedMapIndex >= MapNameList.Count Then
                            SelectedMapIndex = SelectedMapIndex - 1
                        End If
                    End If
                End If


                ' finish rendering
                AgateLib.DisplayLib.Display.EndFrame()
                AgateLib.Core.KeepAlive()


                ' check for exit command
                If GameInputObject.IsESC And Not GameInputObject.OldEsc Then
                    Setup.Dispose()
                    Return "End"
                End If

                ' check if button 1 is pressed
                If GameInputObject.Is1 Then
                    Setup.Dispose()
                    Return "1"
                End If

                ' check if you want to load an item from the menu
                If (GameInputObject.Is2 Or GameInputObject.IsEnter) And SelectedMapIndex <> -1 Then
                    Dim CurrentMapFile As String = Application.StartupPath & "\maps\" & MapNameList(SelectedMapIndex)
                    Do
                        GameMapObject.LoadMap(CurrentMapFile, True)
                        Dim Result = RenderingSub()
                        Dim Processed As Boolean = False

                        If Result = "ESC" Then

                            ' might add something here later

                        ElseIf Result = "DEAD" Then

                            ' put a game over function call here to show game over / continue
                        Else

                            ' split the command to understand what action is required
                            Dim CHRArr() As Char = {vbNewLine, Chr(13), Chr(10)}
                            Dim ResultSplit() = Result.Split(CHRArr, StringSplitOptions.RemoveEmptyEntries)

                            ' process the load command, and load another map
                            If ResultSplit(0) = "load" Then
                                Processed = True

                                ' get the path
                                Dim NewMapPath As String = System.IO.Path.GetDirectoryName(CurrentMapFile)
                                CurrentMapFile = NewMapPath & "\" & ResultSplit(1)
                                If Not CurrentMapFile.ToLower.EndsWith(".map") Then
                                    CurrentMapFile = CurrentMapFile & ".map"
                                End If
                            End If

                        End If
                        If GameMapObject.MapMusic IsNot Nothing Then
                            If GameMapObject.MapMusic.Playing Then
                                GameMapObject.MapMusic.Stop()
                            End If
                        End If

                        If Not Processed Then
                            Exit Do
                        End If
                    Loop

                    Exit Do
                End If


            Loop

        Loop

        Return "End"
    End Function






    ' the main thread related to rendering
    Public Function RenderingSub() As String

        ' increase the priority for the process and the thread just to make sure
        ' that the OS gives enough times for music and prevent unwanted side effects
        Process.GetCurrentProcess.PriorityClass = ProcessPriorityClass.AboveNormal
        Threading.Thread.CurrentThread.Priority = Threading.ThreadPriority.AboveNormal



        ' <<****************************************************************************


        ' set the timers
        GameTimeObject.UpdateGameTime()

        ' >>*****************************************************************************





        ' the character to be rendered
        Dim CurrentCharacter As Hero

        ' check the mode of the heroine
        If GameCreaturesObject.UserCharacter1 IsNot Nothing And GameCreaturesObject.UserCharacter2 IsNot Nothing Then
            GameCreaturesObject.UserCharacter2.ControlMode = CreatureControlModeEnum.ControlModeWaitForPlayer
        End If

        ' the main rendering loop
        Do While Not GameDisplayObject.GameWindow.IsClosed

            ' <<**************************************************************************
            ' 01: update game timer, and keyboard input and prepare the frame

            ' update the keyboard input
            GameInputObject.UpdateControlInputStatusFromKeyboard()

            ' update the time
            GameTimeObject.UpdateGameTime()

            ' begin rendering
            AgateLib.DisplayLib.Display.BeginFrame()

            ' prepare the display by clearing it
            AgateLib.DisplayLib.Display.Clear(255, 51, 153, 204)
            ' >>**************************************************************************

            ' <<**************************************************************************
            ' 02: update the location of the creatures

            ' update player location
            GameCreaturesObject.UpdateUserCharacterLocation(GameInputObject, True, True)

            ' get the current game character
            If GameCreaturesObject.UserCharacter1 IsNot Nothing Then
                If GameCreaturesObject.UserCharacter1.ControlMode = CreatureControlModeEnum.ControlModePlayer Then
                    CurrentCharacter = GameCreaturesObject.UserCharacter1
                Else
                    CurrentCharacter = GameCreaturesObject.UserCharacter2
                End If
            Else
                CurrentCharacter = GameCreaturesObject.UserCharacter2
                GameCreaturesObject.UserCharacter2.ControlMode = CreatureControlModeEnum.ControlModePlayer
            End If


            ' update enemy location
            GameCreaturesObject.UpdateAllEnemies(CurrentCharacter, Nothing)

            ' update box location
            GameCreaturesObject.UpdateAllBoxes(CurrentCharacter, Nothing)

            ' update dynamite location
            GameCreaturesObject.UpdateAllDynamiteAndBomb(CurrentCharacter, Nothing)

            ' update the arrows
            GameCreaturesObject.UpdateAllArrows(CurrentCharacter, Nothing)

            ' update the effects
            GameCreaturesObject.UpdateAllEffects(CurrentCharacter, Nothing)

            ' update all buttons
            GameCreaturesObject.UpdateAllButtons(Nothing, Nothing)

            ' update all gates
            GameCreaturesObject.UpdateAllGates(Nothing, Nothing)

            ' update all arrow sources
            GameCreaturesObject.UpdateAllGates(Nothing, Nothing)

            ' update all arrow sources
            GameCreaturesObject.UpdateAllArrowSources(Nothing, Nothing)

            ' update the location of the display
            GameDisplayObject.EyeX = CurrentCharacter.MapX
            GameDisplayObject.EyeY = CurrentCharacter.MapY
            ' >>****************************************************************************

            ' <<**************************************************************************
            ' 03: Collision detection
            ' check if information should be displayed
            For Each e As Info In GameCreaturesObject.InfoList
                If CurrentCharacter.DoesObjectCollideWithCreature(e.MapX, e.MapY, e.CreatureWidth, e.CreatureHeight) Then
                    If e.MsgTimer = -1 Then
                        e.RenderMsg = True
                        e.MsgTimer = System.Environment.TickCount
                    End If
                Else
                    e.RenderMsg = False
                    e.MsgTimer = -1
                End If
            Next


            ' check if an action should be applied
            For Each e As Action In GameCreaturesObject.ActionList
                e.RenderMsg = False
                If CurrentCharacter.DoesObjectCollideWithCreature(e.MapX, e.MapY, e.CreatureWidth, e.CreatureHeight) Then
                    AgateLib.DisplayLib.Display.EndFrame()
                    Return e.ActionType
                End If
            Next

            ' check the teleport
            If GameInputObject.IsDown And Not GameInputObject.OldDown Then
                Dim TmpTeleport = GameCreaturesObject.GetTeleportCollidingWithCreature(CurrentCharacter)
                If TmpTeleport IsNot Nothing Then
                    Dim TmpTeleport2 = GameCreaturesObject.GetTeleportByName(TmpTeleport.TeleportTo)
                    If TmpTeleport2 IsNot Nothing Then
                        ' found destination, now move
                        CurrentCharacter.MapX = TmpTeleport2.MapX
                        CurrentCharacter.MapY = TmpTeleport2.MapY

                        ' this is needed to prevent any kind of repreated teleport during the same
                        ' processing cycle
                        GameInputObject.OldDown = True
                    End If
                End If
            End If

            ' check first gate 
            Dim TmpGate1 = GameCreaturesObject.GetGate1CollidingWithCreature(CurrentCharacter)
            If TmpGate1 IsNot Nothing AndAlso TmpGate1.Closed Then
                If CurrentCharacter.MapX < TmpGate1.MapX Then
                    CurrentCharacter.MapX = TmpGate1.MapX - (TmpGate1.CreatureWidth + CurrentCharacter.CreatureWidth) \ 2
                Else
                    CurrentCharacter.MapX = TmpGate1.MapX + (TmpGate1.CreatureWidth + CurrentCharacter.CreatureWidth) \ 2
                End If
            End If
            For Each E In GameCreaturesObject.EnemyList
                TmpGate1 = GameCreaturesObject.GetGate1CollidingWithCreature(E)
                If TmpGate1 IsNot Nothing AndAlso TmpGate1.Closed Then
                    If E.MapX < TmpGate1.MapX Then
                        E.MapX = TmpGate1.MapX - (TmpGate1.CreatureWidth + E.CreatureWidth) \ 2
                    Else
                        E.MapX = TmpGate1.MapX + (TmpGate1.CreatureWidth + E.CreatureWidth) \ 2
                    End If
                    E.AccX = -E.AccX
                End If
            Next
            For Each e In GameCreaturesObject.DynamiteAndBombList
                TmpGate1 = GameCreaturesObject.GetGate1CollidingWithCreature(e)
                If TmpGate1 IsNot Nothing AndAlso TmpGate1.Closed Then
                    If e.MapX < TmpGate1.MapX Then
                        e.MapX = TmpGate1.MapX - (TmpGate1.CreatureWidth + e.CreatureWidth) \ 2
                    Else
                        e.MapX = TmpGate1.MapX + (TmpGate1.CreatureWidth + e.CreatureWidth) \ 2
                    End If
                    e.AccX = -e.AccX
                End If
            Next

            ' check second gate 
            Dim TmpGate2 = GameCreaturesObject.GetGate2CollidingWithCreature(CurrentCharacter)
            If TmpGate2 IsNot Nothing AndAlso TmpGate2.Closed Then
                If CurrentCharacter.MapX < TmpGate2.MapX Then
                    CurrentCharacter.MapX = TmpGate2.MapX - (TmpGate2.CreatureWidth + CurrentCharacter.CreatureWidth) \ 2
                Else
                    CurrentCharacter.MapX = TmpGate2.MapX + (TmpGate2.CreatureWidth + CurrentCharacter.CreatureWidth) \ 2
                End If
            End If
            For Each E In GameCreaturesObject.EnemyList
                TmpGate2 = GameCreaturesObject.GetGate2CollidingWithCreature(E)
                If TmpGate2 IsNot Nothing AndAlso TmpGate2.Closed Then
                    If E.MapX < TmpGate2.MapX Then
                        E.MapX = TmpGate2.MapX - (TmpGate2.CreatureWidth + E.CreatureWidth) \ 2
                    Else
                        E.MapX = TmpGate2.MapX + (TmpGate2.CreatureWidth + E.CreatureWidth) \ 2
                    End If
                    E.AccX = -E.AccX
                End If
            Next
            For Each E In GameCreaturesObject.DynamiteAndBombList
                TmpGate2 = GameCreaturesObject.GetGate2CollidingWithCreature(E)
                If TmpGate2 IsNot Nothing AndAlso TmpGate2.Closed Then
                    If E.MapX < TmpGate2.MapX Then
                        E.MapX = TmpGate2.MapX - (TmpGate2.CreatureWidth + E.CreatureWidth) \ 2
                    Else
                        E.MapX = TmpGate2.MapX + (TmpGate2.CreatureWidth + E.CreatureWidth) \ 2
                    End If
                    E.AccX = -E.AccX
                End If
            Next

            ' check the gate button
            For Each e In GameCreaturesObject.ButtonList
                If e.CreatureType = CretureTypeEnum.CreatureType_OnOffButton Then
                    Dim Tmp As OnOffButton = e
                    If CurrentCharacter.DoesObjectCollideWithCreature(e.MapX, e.MapY, e.CreatureWidth, e.CreatureHeight) Then
                        If Not Tmp.LastTimeCollide Then

                            ' update the button
                            Tmp.LastTimeCollide = True
                            Tmp.OnState = Not Tmp.OnState
                            GameSoundsObject.OnOffSound.Play()

                            ' update the gate
                            For Each tmpgate In Tmp.GatesToAffact
                                If tmpgate.ObjectName = Tmp.ObjectToAffact Then
                                    tmpgate.Closed = Not Tmp.OnState
                                    GameSoundsObject.GateSound.Volume = 0.5
                                    GameSoundsObject.GateSound.Play()
                                End If
                            Next
                        End If
                    Else
                        ' remove touch lock
                        Tmp.LastTimeCollide = False
                    End If
                End If
            Next

            ' check the Push button
            For Each E In GameCreaturesObject.ButtonList
                If E.CreatureType = CretureTypeEnum.CreatureType_PushButton Then

                    ' check to see if there is an on off button
                    Dim Tmp As PushButton = E
                    Dim IsPushed As Boolean = False
                    If (GameCreaturesObject.UserCharacter1 IsNot Nothing AndAlso GameCreaturesObject.UserCharacter1.DoesObjectCollideWithCreature(E.MapX, E.MapY, E.CreatureWidth, E.CreatureHeight)) OrElse _
                       (GameCreaturesObject.UserCharacter2 IsNot Nothing AndAlso GameCreaturesObject.UserCharacter2.DoesObjectCollideWithCreature(E.MapX, E.MapY, E.CreatureWidth, E.CreatureHeight)) Then

                        IsPushed = True

                    End If


                    If IsPushed <> Tmp.OnState Then
                        GameSoundsObject.OnOffSound.Play()
                    End If
                    Tmp.OnState = IsPushed

                    ' check to see of other buttons are pushed
                    If Not IsPushed Then
                        For Each tmp2 In Tmp.ButtonsToAffact
                            If tmp2.OnState Then
                                IsPushed = True
                            End If
                        Next
                    End If

                    ' check to see if there are gates that should be affacted
                    For Each Tmp3 As Gate2 In Tmp.GatesToAffact
                        If Tmp3.Closed = IsPushed Then
                            Tmp3.Closed = Not IsPushed
                            GameSoundsObject.GateSound.Volume = 0.5
                            GameSoundsObject.GateSound.Play()
                        End If
                    Next

                End If
            Next

            ' arrow button
            For Each E In GameCreaturesObject.ButtonList

                If E.CreatureType = CretureTypeEnum.CreatureType_ArrowButton Then

                    ' check to see if there is an on off button
                    Dim Tmp As ArrowButton = E
                    Dim IsPushed As Boolean = False
                    If (GameCreaturesObject.UserCharacter1 IsNot Nothing AndAlso GameCreaturesObject.UserCharacter1.DoesObjectCollideWithCreature(E.MapX, E.MapY, E.CreatureWidth, E.CreatureHeight)) OrElse _
                       (GameCreaturesObject.UserCharacter2 IsNot Nothing AndAlso GameCreaturesObject.UserCharacter2.DoesObjectCollideWithCreature(E.MapX, E.MapY, E.CreatureWidth, E.CreatureHeight)) Then

                        IsPushed = True

                    End If


                    If IsPushed <> Tmp.OnState Then
                        GameSoundsObject.OnOffSound.Play()

                        If IsPushed Then
                            ' also trigger the arrow
                            For Each AC In Tmp.ArrowSources

                                ' through an arrow
                                Dim ARR As Arrow = Nothing
                                If AC.ArrowSourceDirection = ArrowSource.ArrowSourceType.ArrowSourceDown Then ARR = New Arrow(AC.MapX, AC.MapY + 32, Arrow.ArrowDirection.ArrowDirectionDown)
                                If AC.ArrowSourceDirection = ArrowSource.ArrowSourceType.ArrowSourceUp Then ARR = New Arrow(AC.MapX, AC.MapY - 32, Arrow.ArrowDirection.ArrowDirectionUp)
                                If AC.ArrowSourceDirection = ArrowSource.ArrowSourceType.ArrowSourceLeft Then ARR = New Arrow(AC.MapX - 32, AC.MapY, Arrow.ArrowDirection.ArrowDirectionLeft)
                                If AC.ArrowSourceDirection = ArrowSource.ArrowSourceType.ArrowSourceRight Then ARR = New Arrow(AC.MapX + 32, AC.MapY, Arrow.ArrowDirection.ArrowDirectionRight)
                                GameSoundsObject.ArrowSound.Play()
                                GameCreaturesObject.ArrowList.Add(ARR)

                            Next

                        End If



                    End If
                    Tmp.OnState = IsPushed

                End If
            Next


            ' check collision with enemy
            For Each e In GameCreaturesObject.EnemyList

                If CurrentCharacter.Unaffected = 0 AndAlso CurrentCharacter.DoesObjectCollideWithCreature(e.MapX, e.MapY, e.CreatureWidth, e.CreatureHeight) AndAlso e.HPEffect > 0 Then
                    ' check to see if there is an enemy

                    ' the user is affacted
                    CurrentCharacter.Unaffected = 100

                    CurrentCharacter.CurrentHP = CurrentCharacter.CurrentHP - e.HPEffect
                    If CurrentCharacter.CurrentHP < 0 Then
                        CurrentCharacter.CurrentHP = 0
                    End If

                    ' generate the sound effect
                    GameSoundsObject.HurtSound.Play()


                    If CurrentCharacter.CurrentHP = 0 Then
                        ' your character is dead
                        AgateLib.DisplayLib.Display.EndFrame()
                        Return "DEAD"
                    End If
                End If
            Next
            ' >>**************************************************************************


            ' <<**************************************************************************
            ' 04: check if your character in drawning
            If CurrentCharacter.CoveredWithWater Then
                If CurrentCharacter.Air <= 0 Then
                    CurrentCharacter.AirCounter += 1000
                    GameSoundsObject.HurtSound.Play()
                    If CurrentCharacter.CurrentHP <= 0 Then
                        ' your character is dead
                        AgateLib.DisplayLib.Display.EndFrame()
                        Return "DEAD"
                    End If
                End If


            End If
            ' >>**************************************************************************


            ' <<**************************************************************************
            ' 05: check weapons

            ' dynamite explosion
            For Each e As Object In GameCreaturesObject.DynamiteAndBombList
                If e.Exploded Then
                    e.Exploded = False
                    GameSoundsObject.DynamiteExplodeSound.Play()
                    If CurrentCharacter.DoesObjectCollideWithCreature(e.MapX, e.MapY, e.CreatureWidth, e.CreatureHeight) And CurrentCharacter.Unaffected = 0 Then

                        ' you are unaffacted for some time
                        CurrentCharacter.Unaffected = 100

                        ' reduce hp
                        CurrentCharacter.CurrentHP = CurrentCharacter.CurrentHP - 10
                        If CurrentCharacter.CurrentHP < 0 Then
                            CurrentCharacter.CurrentHP = 0
                        End If

                        ' generate the sound effect
                        GameSoundsObject.HurtSound.Play()


                        If CurrentCharacter.CurrentHP = 0 Then
                            ' your character is dead
                            AgateLib.DisplayLib.Display.EndFrame()
                            Return "DEAD"
                        End If
                    End If


                    ' check to see if any enemy is affacted by the explosion
                    Dim TmpCounter As Integer
                    For TmpCounter = GameCreaturesObject.EnemyList.Count - 1 To 0 Step -1
                        Dim EE = GameCreaturesObject.AllCreatureList(TmpCounter)
                        If EE.IsRendered AndAlso EE.IsAffactedByExplosion Then

                            If EE.DoesObjectCollideWithCreature(e.MapX, e.MapY, e.CreatureWidth, e.CreatureHeight) Then
                                EE.IsRendered = False
                                GameCreaturesObject.EnemyList.Remove(EE)
                                GameCreaturesObject.AllCreatureList.Remove(EE)
                            End If

                        End If
                    Next


                End If
            Next

            ' check collision with arrows
            For Each e In GameCreaturesObject.ArrowList
                If CurrentCharacter.DoesObjectCollideWithCreature(e.MapX, e.MapY, e.CreatureWidth, e.CreatureHeight) And CurrentCharacter.Unaffected = 0 Then

                    ' you are unaffacted for some time
                    CurrentCharacter.Unaffected = 100

                    ' reduce hp
                    CurrentCharacter.CurrentHP = CurrentCharacter.CurrentHP - 10
                    If CurrentCharacter.CurrentHP < 0 Then
                        CurrentCharacter.CurrentHP = 0
                    End If

                    ' generate the sound effect
                    GameSoundsObject.HurtSound.Play()


                    If CurrentCharacter.CurrentHP = 0 Then
                        ' your character is dead
                        AgateLib.DisplayLib.Display.EndFrame()
                        Return "DEAD"
                    End If
                End If


                ' check to see if any enemy is affacted by the arrow
                Dim TmpCounter As Integer
                For TmpCounter = GameCreaturesObject.EnemyList.Count - 1 To 0 Step -1
                    Dim EE = GameCreaturesObject.AllCreatureList(TmpCounter)
                    If EE.IsRendered AndAlso EE.IsAffactedByArrow Then

                        If EE.DoesObjectCollideWithCreature(e.MapX, e.MapY, e.CreatureWidth, e.CreatureHeight) Then
                            EE.IsRendered = False
                            GameCreaturesObject.EnemyList.Remove(EE)
                            GameCreaturesObject.AllCreatureList.Remove(EE)

                        End If

                    End If
                Next

            Next
            ' >>**************************************************************************

            ' <<**************************************************************************
            ' 06: items

            For Each e In GameCreaturesObject.BoxList

                If e.IsRendered AndAlso CurrentCharacter.DoesObjectCollideWithCreature(e.MapX, e.MapY, e.CreatureWidth, e.CreatureHeight) Then

                    ' if box is empty, then do nothing
                    If e.ItemType = Box.BoxContent.Empty Then
                        e.IsRendered = False
                        GameSoundsObject.OpenBoxSound.Play()
                    End If

                    ' if box contains shoe then
                    If e.ItemType = Box.BoxContent.Shoe Then
                        CurrentCharacter.HasShoe = True
                        e.IsRendered = False
                        GameSoundsObject.FoundShoeSound.Play()
                    End If

                    ' if box contains health then
                    If e.ItemType = Box.BoxContent.Health Then
                        CurrentCharacter.CurrentHP += 10
                        If CurrentCharacter.CurrentHP > CurrentCharacter.MaxHP Then
                            CurrentCharacter.CurrentHP = CurrentCharacter.MaxHP
                        End If
                        e.IsRendered = False
                        GameSoundsObject.HealthSound.Play()
                    End If

                    ' if box contains glove then
                    If e.ItemType = Box.BoxContent.Glove Then
                        If Not CurrentCharacter.StandOnBlocks.Contains(MapBlockType.TreeBranches) Then
                            CurrentCharacter.StandOnBlocks.Add(MapBlockType.TreeBranches)
                            CurrentCharacter.HasGlove = True
                        End If
                        e.IsRendered = False
                        GameSoundsObject.GloveSound.Play()
                    End If

                    ' if box contains some dynamite then
                    If e.ItemType = Box.BoxContent.Dynamite Then
                        CurrentCharacter.DynamiteCount += 3
                        e.IsRendered = False
                        GameSoundsObject.DynamiteSound.Play()
                    End If

                    ' if box contains some bouncing bombs then
                    If e.ItemType = Box.BoxContent.BounceingBomb Then
                        CurrentCharacter.BouncingBombCount += 3
                        e.IsRendered = False
                        GameSoundsObject.BombsSound.Play()
                    End If

                    ' if box an axe then
                    If e.ItemType = Box.BoxContent.Axe Then
                        CurrentCharacter.HasAxe = True
                        e.IsRendered = False
                    End If

                End If
            Next
            ' >>**************************************************************************


            ' <<*****************************************************************************
            ' 07: render the map

            ' render the map
            GameMapObject.RenderMap(False)


            ' render enemies
            For Each e In GameCreaturesObject.AllCreatureList
                e.RenderCreature()
            Next

            ' render boxes
            For Each e In GameCreaturesObject.BoxList
                e.RenderCreature()
            Next

            ' render the character
            If GameCreaturesObject.UserCharacter1 IsNot Nothing Then GameCreaturesObject.UserCharacter1.RenderCreature()
            If GameCreaturesObject.UserCharacter2 IsNot Nothing Then GameCreaturesObject.UserCharacter2.RenderCreature()


            ' render dynamite
            Dim I As Integer
            For I = GameCreaturesObject.DynamiteAndBombList.Count - 1 To 0 Step -1
                If GameCreaturesObject.DynamiteAndBombList(I).IsRendered Then
                    GameCreaturesObject.DynamiteAndBombList(I).RenderCreature()
                Else
                    GameCreaturesObject.DynamiteAndBombList.RemoveAt(I)
                End If
            Next

            ' render the arrow
            For I = GameCreaturesObject.ArrowList.Count - 1 To 0 Step -1
                If GameCreaturesObject.ArrowList(I).IsRendered Then
                    GameCreaturesObject.ArrowList(I).RenderCreature()
                Else
                    GameCreaturesObject.ArrowList.RemoveAt(I)
                End If
            Next

          
            ' render water
            GameMapObject.RenderWaterAndStreetLampInMap()

            ' render the status
            GameStatusObject.RenderStatus(CurrentCharacter)
            ' >>***************************************************************************

            ' <<***************************************************************************
            ' finishing touches
            ' check music

            GameMapObject.PlayMapMusic()


            ' finish rendering
            AgateLib.DisplayLib.Display.EndFrame()
            AgateLib.Core.KeepAlive()


            ' check for exit command
            If GameInputObject.IsESC Then
                GameInputObject.ResetAllKeyboardKeyState()
                Return "ESC"
            End If

            ' check the use item command - space
            If GameInputObject.IsSpace Then

                ' get the direction
                Dim TmpXAcc As Single
                TmpXAcc = CurrentCharacter.AccX
                If TmpXAcc = 0 Then
                    If CurrentCharacter.Direction = CreatueXDirection.LeftDirection Then
                        TmpXAcc = -3
                        If CurrentCharacter.HasShoe Then
                            TmpXAcc = -4
                        End If
                    Else
                        TmpXAcc = 3
                        If CurrentCharacter.HasShoe Then
                            TmpXAcc = 4
                        End If
                    End If
                End If

                If Not GameInputObject.OldSpace AndAlso Not CurrentCharacter.IsUsingAxe Then

                    If CurrentCharacter.CurrentWeapon = Box.BoxContent.Dynamite Then
                        If CurrentCharacter.DynamiteCount > 0 Then
                            CurrentCharacter.DynamiteCount -= 1
                            Dim Z As New IgnitedDynamite(CurrentCharacter.MapX, CurrentCharacter.MapY - 16, TmpXAcc * 1.2, -3)
                            GameCreaturesObject.DynamiteAndBombList.Add(Z)
                        End If
                    ElseIf CurrentCharacter.CurrentWeapon = Box.BoxContent.BounceingBomb Then
                        If CurrentCharacter.BouncingBombCount > 0 Then
                            CurrentCharacter.BouncingBombCount -= 1
                            Dim Z As New IgnitedBouncingBomb(CurrentCharacter.MapX, CurrentCharacter.MapY - 16, TmpXAcc * 1.2, -3)
                            GameCreaturesObject.DynamiteAndBombList.Add(Z)
                        End If
                    ElseIf CurrentCharacter.CurrentWeapon = Box.BoxContent.Axe AndAlso Not CurrentCharacter.IsUsingAxe AndAlso CurrentCharacter.IsStanding Then
                        CurrentCharacter.IsUsingAxe = True
                        CurrentCharacter.IsUsingAxeTimeStamp = System.Environment.TickCount
                        GameSoundsObject.AxeSound.Play()
                    End If


                End If
            End If


        Loop

        Return Nothing
    End Function

    ' the main thread related to rendering
    Public Sub RenderingMapSub()
        Dim TmpCount As Long = 0
        Dim TmpLast As Integer = 0
        Dim CurrentPage As String = "Player page"

        ' <<****************************************************************************
        If GameCreaturesObject.BoxList Is Nothing Then GameCreaturesObject.BoxList = New List(Of Box)

        ' create the pointer
        Dim Pointer = New AgateLib.DisplayLib.Surface(Application.StartupPath & "\images\pointer.png")
        Dim TextSurface As New AgateLib.DisplayLib.FontSurface("Times", 10, AgateLib.DisplayLib.FontStyle.Bold)


        If GameCreaturesObject.UserCharacter1 Is Nothing Then
            GameCreaturesObject.UserCharacter1 = New Hero
            GameCreaturesObject.UserCharacter1.MapX = 32
            GameCreaturesObject.UserCharacter1.MapY = 160
            GameCreaturesObject.UserCharacter1.AccX = 0
            GameCreaturesObject.UserCharacter1.AccY = 0
            GameCreaturesObject.UserCharacter1.Unaffected = 0
            GameCreaturesObject.UserCharacter1.IsRendered = False
        Else
            GameCreaturesObject.UserCharacter1.Unaffected = 0
            GameCreaturesObject.UserCharacter1.IsRendered = True
        End If

        If GameCreaturesObject.UserCharacter2 Is Nothing Then
            GameCreaturesObject.UserCharacter2 = New Heroine
            GameCreaturesObject.UserCharacter2.MapX = 32
            GameCreaturesObject.UserCharacter2.MapY = 160
            GameCreaturesObject.UserCharacter2.AccX = 0
            GameCreaturesObject.UserCharacter2.AccY = 0
            GameCreaturesObject.UserCharacter2.Unaffected = 0
            GameCreaturesObject.UserCharacter2.IsRendered = False
        Else
            GameCreaturesObject.UserCharacter2.Unaffected = 0
            GameCreaturesObject.UserCharacter2.IsRendered = True
        End If


        If GameCreaturesObject.AllCreatureList Is Nothing Then
            GameCreaturesObject.AllCreatureList = New List(Of BaseCreature)
        End If


        GameDisplayObject.EyeX = 32
        GameDisplayObject.EyeY = 32
        ' >>*****************************************************************************

        ' prepare some map view variables
        Dim TmpWidth = GameDisplayObject.MyDisplayWidth
        Dim TmpHeight = GameDisplayObject.MyDisplayHeight
        GameMapObject.GameMapActualWidth = GameMapObject.GameMap.GetLength(0) * 16
        GameMapObject.GameMapActualHeight = GameMapObject.GameMap.GetLength(1) * 16
        GameDisplayObject.MidDisplayX = GameDisplayObject.MyDisplayWidth / 2
        GameDisplayObject.MidDisplayY = GameDisplayObject.MyDisplayHeight / 2

        ' check to see if the whole map fits in the display
        If GameMapObject.GameMapActualWidth < TmpWidth Then TmpWidth = GameMapObject.GameMapActualWidth
        If GameMapObject.GameMapActualHeight < TmpHeight Then TmpHeight = GameMapObject.GameMapActualHeight

        ' set the timers
        GameTimeObject.UpdateGameTime()


        ' the main rendering loop
        Do While Not GameDisplayObject.GameWindow.IsClosed


            ' update the time
            GameTimeObject.UpdateGameTime()

            ' wait a little bit or stop consuming resources
            ' Application.DoEvents()

            ' begin rendering
            AgateLib.DisplayLib.Display.BeginFrame()

            ' prepare the display by clearing it
            AgateLib.DisplayLib.Display.Clear(255, 51, 153, 204)


            ' render the map
            GameMapObject.RenderMap(True)

            ' <<*****************************************************************************
            ' render the creature
            GameCreaturesObject.UserCharacter1.RenderCreature()
            GameCreaturesObject.UserCharacter2.RenderCreature()
            For Each e In GameCreaturesObject.AllCreatureList
                e.RenderCreature()
            Next
            For Each e In GameCreaturesObject.BoxList
                e.RenderCreature()
            Next
            ' >>******************************************************************************




            ' <<*****************************************************************************
            ' render notes and info to make the end user understand what to do
            AgateLib.DisplayLib.Display.FillRect(0, 0, GameDisplayObject.MyDisplayWidth, 100, AgateLib.Geometry.Color.Black)

            ' location
            TextSurface.DrawText(0, 0, "X: " & GameDisplayObject.EyeX)
            TextSurface.DrawText(0, 12, "Y: " & GameDisplayObject.EyeY)
            TextSurface.DrawText(0, 24, "Page:" & CurrentPage)

            ' action to do
            Dim ActionToDo As String = ""


            ' update keyboard state
            GameInputObject.UpdateControlInputStatusFromKeyboard()

            If CurrentPage.ToLower = "player page" Then
                TextSurface.DrawText(150, 12 * 0, "1: next page")
                TextSurface.DrawText(150, 12 * 1, "2: set hero location")
                TextSurface.DrawText(150, 12 * 2, "3: add information")
                TextSurface.DrawText(150, 12 * 3, "4: add action")
                TextSurface.DrawText(150, 12 * 4, "5: set heroine location")

                If GameInputObject.Is1 Then ActionToDo = "next page"
                If GameInputObject.Is2 Then ActionToDo = "set player location"
                If GameInputObject.Is3 Then ActionToDo = "information bubble"
                If GameInputObject.Is4 Then ActionToDo = "action bubble"
                If GameInputObject.Is5 Then ActionToDo = "set player2 location"


            ElseIf CurrentPage.ToLower = "weapons and items" Then

                TextSurface.DrawText(150, 12 * 0, "1: next page")
                TextSurface.DrawText(150, 12 * 1, "2: health box")
                TextSurface.DrawText(150, 12 * 2, "3: gloves box")
                TextSurface.DrawText(150, 12 * 3, "4: dynamite box")
                TextSurface.DrawText(150, 12 * 4, "5: bouncing bomb box")
                TextSurface.DrawText(150, 12 * 5, "6: shoe box")
                TextSurface.DrawText(300, 12 * 0, "7: axe box")

                If GameInputObject.Is1 Then ActionToDo = "next page"
                If GameInputObject.Is2 Then ActionToDo = "health box"
                If GameInputObject.Is3 Then ActionToDo = "gloves box"
                If GameInputObject.Is4 Then ActionToDo = "dynamite box"
                If GameInputObject.Is5 Then ActionToDo = "bouncing bomb box"
                If GameInputObject.Is6 Then ActionToDo = "shoe box"
                If GameInputObject.Is7 Then ActionToDo = "axe box"

            ElseIf CurrentPage.ToLower = "platforms" Then
                TextSurface.DrawText(150, 12 * 0, "1: next page")
                TextSurface.DrawText(150, 12 * 1, "2: empty block")
                TextSurface.DrawText(150, 12 * 2, "3: brick block")
                TextSurface.DrawText(150, 12 * 3, "4: grass block")
                TextSurface.DrawText(150, 12 * 4, "5: rocks block")
                TextSurface.DrawText(300, 12 * 0, "6: tree branches")
                TextSurface.DrawText(300, 12 * 1, "7: weak brick")

                If GameInputObject.Is1 Then ActionToDo = "next page"
                If GameInputObject.Is2 Then ActionToDo = "empty block"
                If GameInputObject.Is3 Then ActionToDo = "brick block"
                If GameInputObject.Is4 Then ActionToDo = "grass block"
                If GameInputObject.Is5 Then ActionToDo = "rocks block"
                If GameInputObject.Is6 Then ActionToDo = "tree branches"
                If GameInputObject.Is7 Then ActionToDo = "weak brick"

            ElseIf CurrentPage.ToLower = "enemies" Then
                TextSurface.DrawText(150, 12 * 0, "1: next page")
                TextSurface.DrawText(150, 12 * 1, "2: spider enemy")
                TextSurface.DrawText(150, 12 * 2, "3: monkey enemy")
                TextSurface.DrawText(150, 12 * 3, "4: stupid ememy")
                TextSurface.DrawText(150, 12 * 4, "5: presistant enemy")
                TextSurface.DrawText(150, 12 * 5, "6: wolfman enemy")
                TextSurface.DrawText(300, 12 * 0, "7: bat enemy")

                If GameInputObject.Is1 Then ActionToDo = "next page"
                If GameInputObject.Is2 Then ActionToDo = "spider enemy"
                If GameInputObject.Is3 Then ActionToDo = "monkey enemy"
                If GameInputObject.Is4 Then ActionToDo = "stupid enemy"
                If GameInputObject.Is5 Then ActionToDo = "presistant enemy"
                If GameInputObject.Is6 Then ActionToDo = "wolfman enemy"
                If GameInputObject.Is7 Then ActionToDo = "bat enemy"

            ElseIf CurrentPage.ToLower = "other" Then

                TextSurface.DrawText(150, 12 * 0, "1: next page")
                TextSurface.DrawText(150, 12 * 1, "2: water block")
                TextSurface.DrawText(150, 12 * 2, "3: background grass")
                TextSurface.DrawText(150, 12 * 3, "4: leaves")
                TextSurface.DrawText(150, 12 * 4, "5: tree trunk")
                TextSurface.DrawText(150, 12 * 5, "6: small tree")
                TextSurface.DrawText(300, 12 * 0, "7: large tree")
                TextSurface.DrawText(300, 12 * 1, "8: broken space ship")
                TextSurface.DrawText(300, 12 * 2, "9: hut")
                TextSurface.DrawText(300, 12 * 3, "0: space ship")
                TextSurface.DrawText(300, 12 * 4, "Q: smoke")
                TextSurface.DrawText(300, 12 * 5, "Y: door 6x6")
                TextSurface.DrawText(450, 12 * 0, "U: Window 6x6")
                TextSurface.DrawText(450, 12 * 1, "I: Brick 6x6")
                TextSurface.DrawText(450, 12 * 2, "O: Street Lamp")
                TextSurface.DrawText(450, 12 * 3, "W: Window 6x6 transperent")
                TextSurface.DrawText(450, 12 * 4, "P: door 6x6-2")
                TextSurface.DrawText(450, 12 * 5, "A: window 6x6-2")
                TextSurface.DrawText(600, 12 * 0, "S: brick 6x6-2")
                TextSurface.DrawText(600, 12 * 1, "D: brick 6x6-3")
                TextSurface.DrawText(600, 12 * 2, "F: brick small 1")
                TextSurface.DrawText(600, 12 * 3, "G: brick small 2")
                TextSurface.DrawText(600, 12 * 4, "H: brick small 3")

                If GameInputObject.IsP Then ActionToDo = "door 6x6-2"
                If GameInputObject.IsA Then ActionToDo = "window 6x6-2"
                If GameInputObject.IsS Then ActionToDo = "brick 6x6-2"
                If GameInputObject.IsD Then ActionToDo = "brick 6x6-3"
                If GameInputObject.IsF Then ActionToDo = "small brick-1"
                If GameInputObject.IsG Then ActionToDo = "small brick-2"
                If GameInputObject.IsH Then ActionToDo = "small brick-3"
                If GameInputObject.Is1 Then ActionToDo = "next page"
                If GameInputObject.Is2 Then ActionToDo = "water block"
                If GameInputObject.Is3 Then ActionToDo = "background grass"
                If GameInputObject.Is4 Then ActionToDo = "background leaves"
                If GameInputObject.Is5 Then ActionToDo = "tree trunk"
                If GameInputObject.Is6 Then ActionToDo = "small tree"
                If GameInputObject.Is7 Then ActionToDo = "large tree"
                If GameInputObject.Is8 Then ActionToDo = "broken space ship"
                If GameInputObject.Is9 Then ActionToDo = "hut"
                If GameInputObject.Is0 Then ActionToDo = "space ship"
                If GameInputObject.IsQ Then ActionToDo = "smoke"
                If GameInputObject.IsY Then ActionToDo = "gray door"
                If GameInputObject.IsU Then ActionToDo = "Window 6x6"
                If GameInputObject.IsI Then ActionToDo = "Brick 6x6"
                If GameInputObject.IsO Then ActionToDo = "Street Lamp"
                If GameInputObject.IsW Then ActionToDo = "Window 6x6 transperent"


            ElseIf CurrentPage.ToLower = "other 2" Then

                TextSurface.DrawText(150, 12 * 0, "1: next page")
                TextSurface.DrawText(150, 12 * 1, "2: gen. random map")
                TextSurface.DrawText(150, 12 * 2, "3: save map")
                TextSurface.DrawText(150, 12 * 3, "4: load map")

                If GameInputObject.Is1 Then ActionToDo = "next page"
                If GameInputObject.Is2 Then ActionToDo = "gen. random map"
                If GameInputObject.Is3 Then ActionToDo = "save map"
                If GameInputObject.Is4 Then ActionToDo = "load map"

            ElseIf CurrentPage.ToLower = "gates and switches" Then
                TextSurface.DrawText(150, 12 * 0, "1: next page")
                TextSurface.DrawText(150, 12 * 1, "2: on/off button")
                TextSurface.DrawText(150, 12 * 2, "3: gate")
                TextSurface.DrawText(150, 12 * 3, "4: Teleport")
                TextSurface.DrawText(150, 12 * 4, "5: push button")
                TextSurface.DrawText(150, 12 * 5, "6: gate 2")
                TextSurface.DrawText(300, 12 * 0, "7: arrow button")
                TextSurface.DrawText(300, 12 * 1, "8: arrow source")

                If GameInputObject.Is1 Then ActionToDo = "next page"
                If GameInputObject.Is2 Then ActionToDo = "on/off button"
                If GameInputObject.Is3 Then ActionToDo = "gate"
                If GameInputObject.Is4 Then ActionToDo = "teleport"
                If GameInputObject.Is5 Then ActionToDo = "push button"
                If GameInputObject.Is6 Then ActionToDo = "gate 2"
                If GameInputObject.Is7 Then ActionToDo = "arrow button"
                If GameInputObject.Is8 Then ActionToDo = "arrow source"

            End If

            ' check if the user want to remove a block
            If GameInputObject.IsZ Then
                ActionToDo = "empty block"
            End If

            ' few commands require keyboard reset.
            If ActionToDo = "save map" Or ActionToDo = "information bubble" Or ActionToDo = "action bubble" Or _
               ActionToDo = "load map" Or ActionToDo = "on/off button" Or ActionToDo = "gate" Or ActionToDo = "next page" Or _
               ActionToDo = "teleport" Or ActionToDo = "push button" Or ActionToDo = "gate 2" Or ActionToDo = "arrow button" Or _
               ActionToDo = "arrow source" Then
                GameInputObject.ResetAllKeyboardKeyState()
            End If


            ' commands
            If ActionToDo = "next page" Then
                If CurrentPage.ToLower = "player page" Then
                    CurrentPage = "Weapons and Items"
                ElseIf CurrentPage.ToLower = "weapons and items" Then
                    CurrentPage = "Platforms"
                ElseIf CurrentPage.ToLower = "platforms" Then
                    CurrentPage = "enemies"
                ElseIf CurrentPage.ToLower = "enemies" Then
                    CurrentPage = "Other"
                ElseIf CurrentPage.ToLower = "other" Then
                    CurrentPage = "Other 2"
                ElseIf CurrentPage.ToLower = "other 2" Then
                    CurrentPage = "Gates and Switches"
                ElseIf CurrentPage.ToLower = "gates and switches" Then
                    CurrentPage = "Player Page"
                End If
            End If



            ' clear items flag
            Dim ClearItem As Boolean = False
            Dim EyeXDiv16 As Long = GameDisplayObject.EyeX \ 16
            Dim EyeYDiv16 As Long = GameDisplayObject.EyeY \ 16


            If ActionToDo = "weak brick" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.BreakableBrick
            If ActionToDo = "door 6x6-2" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.GrayDoor_2
            If ActionToDo = "window 6x6-2" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.Window6x6_2
            If ActionToDo = "brick 6x6-2" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.Brick6x6_2
            If ActionToDo = "brick 6x6-3" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.Brick6x6_3
            If ActionToDo = "small brick-1" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.SmallBackgroundBrick_1
            If ActionToDo = "small brick-2" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.SmallBackgroundBrick_2
            If ActionToDo = "small brick-3" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.SmallBackgroundBrick_3
            If ActionToDo = "Window 6x6 transperent" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.Window6x6Transperent
            If ActionToDo = "gray door" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.GrayDoor
            If ActionToDo = "Window 6x6" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.Window6x6
            If ActionToDo = "Brick 6x6" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.Brick6x6
            If ActionToDo = "Street Lamp" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.StreetLamp
            If ActionToDo = "empty block" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.EmptyBlock : ClearItem = True
            If ActionToDo = "brick block" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.BrickBlock
            If ActionToDo = "grass block" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.GrassBlock
            If ActionToDo = "water block" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.WaterBlock
            If ActionToDo = "rocks block" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.RocksBlock
            If ActionToDo = "background grass" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.Grass
            If ActionToDo = "background leaves" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.leaves
            If ActionToDo = "tree trunk" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.TreeTrank
            If ActionToDo = "small tree" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.FullTree
            If ActionToDo = "large tree" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.FullTree2
            If ActionToDo = "tree branches" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.TreeBranches
            If ActionToDo = "broken space ship" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.BrokenSpaceShip
            If ActionToDo = "hut" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.Hut
            If ActionToDo = "space ship" Then GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.SpaceShip
            If ActionToDo = "gen. random map" Then
                Dim RC = InputBox("Enter the number of rock layers", "Rock layers", 3)
                Dim TC = InputBox("Enter the number of trees", "Trees", 3)
                Dim LC = InputBox("Enter the number of water ponds", "Water", 3)

                GameMapObject.CreateRandomMap(GameMapObject.GameMap.GetLength(0), GameMapObject.GameMap.GetLength(1), RC, TC, LC)
                GameInputObject.ResetAllKeyboardKeyState()
            End If


            ' saving
            If ActionToDo = "save map" Then
                If GameCreaturesObject.UserCharacter1.IsRendered Or GameCreaturesObject.UserCharacter2.IsRendered Then
                    Dim SFD As New SaveFileDialog
                    SFD.Filter = "*.map|*.map"
                    If SFD.ShowDialog = DialogResult.OK Then
                        GameMapObject.SaveMap(SFD.FileName, GameCreaturesObject.UserCharacter1, GameCreaturesObject.UserCharacter2, GameCreaturesObject.AllCreatureList, GameCreaturesObject.BoxList)
                    End If
                End If
            End If

            ' loading
            If ActionToDo = "load map" Then
                Dim OFD As New OpenFileDialog
                OFD.Filter = "*.map|*.map"
                If OFD.ShowDialog = DialogResult.OK Then
                    GameMapObject.LoadMap(OFD.FileName, False)
                End If
            End If

            Threading.Thread.Sleep(10)

            ' >>***************************************************************************

            ' clear the player or enemy unit if needed
            If ClearItem Then

                ' clear the hero
                If (GameCreaturesObject.UserCharacter1.MapX = GameDisplayObject.EyeX + 8 And GameCreaturesObject.UserCharacter1.MapY = GameDisplayObject.EyeY + 16) Or _
                   (GameCreaturesObject.UserCharacter1.MapX = GameDisplayObject.EyeX + 8 And GameCreaturesObject.UserCharacter1.MapY = GameDisplayObject.EyeY + 32) Then
                    GameCreaturesObject.UserCharacter1.IsRendered = False
                    GameCreaturesObject.UserCharacter1.MapX = 0
                    GameCreaturesObject.UserCharacter1.MapY = 0
                End If

                ' clear the heroine
                If (GameCreaturesObject.UserCharacter2.MapX = GameDisplayObject.EyeX + 8 And GameCreaturesObject.UserCharacter2.MapY = GameDisplayObject.EyeY + 16) Or _
                   (GameCreaturesObject.UserCharacter2.MapX = GameDisplayObject.EyeX + 8 And GameCreaturesObject.UserCharacter2.MapY = GameDisplayObject.EyeY + 32) Then
                    GameCreaturesObject.UserCharacter2.IsRendered = False
                    GameCreaturesObject.UserCharacter2.MapX = 0
                    GameCreaturesObject.UserCharacter2.MapY = 0
                End If

                ' clear the enemy
                For i = GameCreaturesObject.AllCreatureList.Count - 1 To 0 Step -1
                    If (GameCreaturesObject.AllCreatureList(i).MapX = GameDisplayObject.EyeX + 8 And GameCreaturesObject.AllCreatureList(i).MapY = GameDisplayObject.EyeY + 16) Or _
                       (GameCreaturesObject.AllCreatureList(i).MapX = GameDisplayObject.EyeX + 8 And GameCreaturesObject.AllCreatureList(i).MapY = GameDisplayObject.EyeY + 32) Then
                        GameCreaturesObject.AllCreatureList.RemoveAt(i)
                    End If
                Next

                ' clear boxes
                For i = GameCreaturesObject.BoxList.Count - 1 To 0 Step -1
                    If (GameCreaturesObject.BoxList(i).MapX = GameDisplayObject.EyeX + 8 And GameCreaturesObject.BoxList(i).MapY = GameDisplayObject.EyeY + 16) Or _
                       (GameCreaturesObject.BoxList(i).MapX = GameDisplayObject.EyeX + 8 And GameCreaturesObject.BoxList(i).MapY = GameDisplayObject.EyeY + 32) Then
                        GameCreaturesObject.BoxList.RemoveAt(i)
                    End If
                Next
            End If


            ' draw the pointer
            Pointer.Draw(GameDisplayObject.EyeX - GameMapObject.ViewX1 + GameMapObject.ViewXShift, GameDisplayObject.EyeY - GameMapObject.ViewY1 + GameMapObject.ViewYShift)


            ' finish rendering
            AgateLib.DisplayLib.Display.EndFrame()
            AgateLib.Core.KeepAlive()


            ' check for exit command
            If GameInputObject.IsESC Then
                Setup.Dispose()
                End
            End If


            ' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            ' move arrows
            Dim FG As Boolean = False
            Dim Jmp As Integer = 1
            If GameInputObject.IsControl Then
                Jmp = 100
            End If

            ' move up
            If GameInputObject.IsUp Then
                FG = True
                GameInputObject.ResetAllKeyboardKeyState()
                If TmpLast = AgateLib.InputLib.KeyCode.Up Then
                    TmpCount += 1
                    If TmpCount > 50 Then
                        GameDisplayObject.EyeY = GameDisplayObject.EyeY - 16 * Jmp
                    End If
                Else
                    TmpLast = AgateLib.InputLib.KeyCode.Up
                    TmpCount = 0
                    GameDisplayObject.EyeY = GameDisplayObject.EyeY - 16 * Jmp
                End If
            End If

            'move down
            If GameInputObject.IsDown Then
                FG = True
                GameInputObject.ResetAllKeyboardKeyState()
                If TmpLast = AgateLib.InputLib.KeyCode.Down Then
                    TmpCount += 1
                    If TmpCount > 50 Then
                        GameDisplayObject.EyeY = GameDisplayObject.EyeY + 16 * Jmp
                    End If
                Else
                    TmpLast = AgateLib.InputLib.KeyCode.Down
                    TmpCount = 0
                    GameDisplayObject.EyeY = GameDisplayObject.EyeY + 16 * Jmp
                End If
            End If
            ' move right
            If GameInputObject.IsRight Then
                FG = True
                GameInputObject.ResetAllKeyboardKeyState()
                If TmpLast = AgateLib.InputLib.KeyCode.Right Then
                    TmpCount += 1
                    If TmpCount > 50 Then
                        GameDisplayObject.EyeX = GameDisplayObject.EyeX + 16 * Jmp
                    End If
                Else
                    TmpLast = AgateLib.InputLib.KeyCode.Right
                    TmpCount = 0
                    GameDisplayObject.EyeX = GameDisplayObject.EyeX + 16 * Jmp
                End If
            End If
            ' move left
            If GameInputObject.IsLeft Then
                FG = True
                GameInputObject.ResetAllKeyboardKeyState()
                If TmpLast = AgateLib.InputLib.KeyCode.Left Then
                    TmpCount += 1
                    If TmpCount > 50 Then
                        GameDisplayObject.EyeX = GameDisplayObject.EyeX - 16 * Jmp
                    End If
                Else
                    TmpLast = AgateLib.InputLib.KeyCode.Left
                    TmpCount = 0
                    GameDisplayObject.EyeX = GameDisplayObject.EyeX - 16 * Jmp
                End If
            End If

            ' set the player
            If ActionToDo = "set player location" Then
                FG = True
                GameCreaturesObject.UserCharacter1.MapX = GameDisplayObject.EyeX + 8
                GameCreaturesObject.UserCharacter1.MapY = GameDisplayObject.EyeY + 32
                GameCreaturesObject.UserCharacter1.IsRendered = True
            End If

            If ActionToDo = "set player2 location" Then
                FG = True
                GameCreaturesObject.UserCharacter2.MapX = GameDisplayObject.EyeX + 8
                GameCreaturesObject.UserCharacter2.MapY = GameDisplayObject.EyeY + 32
                GameCreaturesObject.UserCharacter2.IsRendered = True
            End If

            ' add stupid enemy
            If ActionToDo = "stupid enemy" Then
                FG = True
                Dim X As New StupidEnemy
                X.MapX = GameDisplayObject.EyeX + 8
                X.MapY = GameDisplayObject.EyeY + 16
                GameMapObject.GameMap(EyeXDiv16, EyeYDiv16) = MapBlockType.EmptyBlock
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.AllCreatureList.Add(X)
            End If

            ' add spider enemy
            If ActionToDo = "spider enemy" Then
                FG = True
                Dim X As New SpiderEnemy
                X.MapX = GameDisplayObject.EyeX + 8
                X.MapY = GameDisplayObject.EyeY + 16
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.AllCreatureList.Add(X)
            End If



            ' wolfman enemy
            If ActionToDo = "wolfman enemy" Then
                FG = True
                Dim X As New WolfmanEnemy
                X.MapX = GameDisplayObject.EyeX + 8
                X.MapY = GameDisplayObject.EyeY + 32
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.AllCreatureList.Add(X)
            End If


            ' presistant enemy
            If ActionToDo = "presistant enemy" Then
                FG = True
                Dim X As New PresistantEnemy
                X.MapX = GameDisplayObject.EyeX + 8
                X.MapY = GameDisplayObject.EyeY + 32
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.AllCreatureList.Add(X)
            End If

            ' monkey enemy
            If ActionToDo = "monkey enemy" Then
                FG = True
                Dim X As New MonkeyEnemy
                X.MapX = GameDisplayObject.EyeX + 8
                X.MapY = GameDisplayObject.EyeY + 32
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.AllCreatureList.Add(X)
            End If

            ' bat enemy
            If ActionToDo = "bat enemy" Then
                FG = True
                Dim X As New BatEnemy
                X.MapX = GameDisplayObject.EyeX + 8
                X.MapY = GameDisplayObject.EyeY + 32
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.AllCreatureList.Add(X)
            End If

            ' some smoke
            If ActionToDo = "smoke" Then
                FG = True
                Dim X As New Smoke
                X.MapX = GameDisplayObject.EyeX + 8
                X.MapY = GameDisplayObject.EyeY + 32
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.AllCreatureList.Add(X)
            End If

            ' some information
            If ActionToDo = "information bubble" Then
                FG = True
                Dim Win As New TextReadWindow
                Dim MSG As String
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG = ""
                Else
                    MSG = Win.TextBox1.Text
                    MSG = MSG.Replace(vbNewLine, Chr(10))
                End If
                If MSG <> "" Then
                    Dim X As New Info
                    X.Message = MSG
                    X.MapX = GameDisplayObject.EyeX + 8
                    X.MapY = GameDisplayObject.EyeY + 32
                    GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                    GameCreaturesObject.AllCreatureList.Add(X)
                End If
            End If

            ' some information
            If ActionToDo = "arrow source" Then
                FG = True
                Dim Win As New TextReadWindow
                Dim MSG As String
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG = ""
                Else
                    MSG = Win.TextBox1.Text
                    MSG = MSG.Replace(vbNewLine, Chr(10))
                End If
                If MSG <> "" Then
                    Dim CNT As Boolean = False
                    Dim X As ArrowSource = Nothing
                    If Win.ShowDialog <> DialogResult.Cancel Then
                        If Win.TextBox1.Text = "r" Or Win.TextBox1.Text = "right" Then
                            X = New ArrowSource(ArrowSource.ArrowSourceType.ArrowSourceRight)
                        End If
                        If Win.TextBox1.Text = "l" Or Win.TextBox1.Text = "left" Then
                            X = New ArrowSource(ArrowSource.ArrowSourceType.ArrowSourceLeft)
                        End If
                        If Win.TextBox1.Text = "u" Or Win.TextBox1.Text = "up" Then
                            X = New ArrowSource(ArrowSource.ArrowSourceType.ArrowSourceUp)
                        End If
                        If Win.TextBox1.Text = "d" Or Win.TextBox1.Text = "down" Then
                            X = New ArrowSource(ArrowSource.ArrowSourceType.ArrowSourceDown)
                        End If
                    End If
                    If X IsNot Nothing Then
                        X.ObjectName = MSG
                        X.MapX = GameDisplayObject.EyeX + 8
                        X.MapY = GameDisplayObject.EyeY + 32
                        GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                        GameCreaturesObject.AllCreatureList.Add(X)
                    End If

                End If
            End If

            ' action
            If ActionToDo = "action bubble" Then
                FG = True
                Dim Win As New TextReadWindow
                Dim MSG As String
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG = ""
                Else
                    MSG = Win.TextBox1.Text
                    MSG = MSG.Replace(vbNewLine, Chr(10))
                End If
                If MSG <> "" Then
                    Dim X As New Action
                    X.ActionType = MSG
                    X.MapX = GameDisplayObject.EyeX + 8
                    X.MapY = GameDisplayObject.EyeY + 32
                    GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                    GameCreaturesObject.AllCreatureList.Add(X)
                End If
            End If

            ' on off button
            If ActionToDo = "on/off button" Then
                FG = True
                Dim Win As New TextReadWindow
                Dim MSG As String
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG = ""
                Else
                    MSG = Win.TextBox1.Text
                    MSG = MSG.Replace(vbNewLine, Chr(10))
                End If
                If MSG <> "" Then
                    Dim X As New OnOffButton
                    X.ObjectToAffact = MSG
                    X.MapX = GameDisplayObject.EyeX + 8
                    X.MapY = GameDisplayObject.EyeY + 32
                    GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                    GameCreaturesObject.AllCreatureList.Add(X)
                End If
            End If

            ' push button
            If ActionToDo = "push button" Then
                FG = True
                Dim Win As New TextReadWindow
                Dim MSG As String
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG = ""
                Else
                    MSG = Win.TextBox1.Text
                    MSG = MSG.Replace(vbNewLine, Chr(10))
                End If
                If MSG <> "" Then
                    Dim X As New PushButton
                    X.ObjectToAffact = MSG
                    X.MapX = GameDisplayObject.EyeX + 8
                    X.MapY = GameDisplayObject.EyeY + 32
                    GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                    GameCreaturesObject.AllCreatureList.Add(X)
                End If
            End If

            ' arrow button
            If ActionToDo = "arrow button" Then
                FG = True
                Dim Win As New TextReadWindow
                Dim MSG As String
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG = ""
                Else
                    MSG = Win.TextBox1.Text
                    MSG = MSG.Replace(vbNewLine, Chr(10))
                End If
                If MSG <> "" Then
                    Dim X As New ArrowButton
                    X.ObjectToAffact = MSG
                    X.MapX = GameDisplayObject.EyeX + 8
                    X.MapY = GameDisplayObject.EyeY + 32
                    GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                    GameCreaturesObject.AllCreatureList.Add(X)
                End If
            End If

            ' on gate
            If ActionToDo = "gate" Then
                FG = True
                Dim Win As New TextReadWindow
                Dim MSG As String
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG = ""
                Else
                    MSG = Win.TextBox1.Text
                    MSG = MSG.Replace(vbNewLine, Chr(10))
                End If
                If MSG <> "" Then
                    Dim X As New Gate
                    X.ObjectName = MSG
                    X.MapX = GameDisplayObject.EyeX + 8
                    X.MapY = GameDisplayObject.EyeY + 32
                    GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                    GameCreaturesObject.AllCreatureList.Add(X)
                End If
            End If

            ' on gate 2
            If ActionToDo = "gate 2" Then
                FG = True
                Dim Win As New TextReadWindow
                Dim MSG As String
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG = ""
                Else
                    MSG = Win.TextBox1.Text
                    MSG = MSG.Replace(vbNewLine, Chr(10))
                End If
                If MSG <> "" Then
                    Dim X As New Gate2
                    X.ObjectName = MSG
                    X.MapX = GameDisplayObject.EyeX + 8
                    X.MapY = GameDisplayObject.EyeY + 32
                    GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                    GameCreaturesObject.AllCreatureList.Add(X)
                End If
            End If

            ' teleport
            If ActionToDo = "teleport" Then
                FG = True
                Dim Win As New TextReadWindow
                Dim MSG As String
                Dim MSG2 As String
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG = ""
                Else
                    MSG = Win.TextBox1.Text
                    MSG = MSG.Replace(vbNewLine, Chr(10))
                End If
                If Win.ShowDialog = DialogResult.Cancel Then
                    MSG2 = ""
                Else
                    MSG2 = Win.TextBox1.Text
                    MSG2 = MSG2.Replace(vbNewLine, Chr(10))
                End If

                If MSG2 <> "" And MSG <> "" Then
                    Dim X As New Teleport
                    X.ObjectName = MSG
                    X.TeleportTo = MSG2
                    X.MapX = GameDisplayObject.EyeX + 8
                    X.MapY = GameDisplayObject.EyeY + 32
                    GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                    GameCreaturesObject.AllCreatureList.Add(X)
                End If
            End If


            ' add health kit box
            If ActionToDo = "health box" Then
                FG = True
                Dim X As New Box(Box.BoxContent.Health, GameDisplayObject.EyeX + 8, GameDisplayObject.EyeY + 16)
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.BoxList.Add(X)
            End If

            ' add glove box
            If ActionToDo = "gloves box" Then
                FG = True
                Dim X As New Box(Box.BoxContent.Glove, GameDisplayObject.EyeX + 8, GameDisplayObject.EyeY + 16)
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.BoxList.Add(X)
            End If

            ' add dynamite box
            If ActionToDo = "dynamite box" Then
                FG = True
                Dim X As New Box(Box.BoxContent.Dynamite, GameDisplayObject.EyeX + 8, GameDisplayObject.EyeY + 16)
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.BoxList.Add(X)
            End If

            ' add bouncing bomb box
            If ActionToDo = "bouncing bomb box" Then
                FG = True
                Dim X As New Box(Box.BoxContent.BounceingBomb, GameDisplayObject.EyeX + 8, GameDisplayObject.EyeY + 16)
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.BoxList.Add(X)
            End If

            ' add shoe box
            If ActionToDo = "shoe box" Then
                FG = True
                Dim X As New Box(Box.BoxContent.Shoe, GameDisplayObject.EyeX + 8, GameDisplayObject.EyeY + 16)
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.BoxList.Add(X)
            End If

            ' add axe box
            If ActionToDo = "axe box" Then
                FG = True
                Dim X As New Box(Box.BoxContent.Axe, GameDisplayObject.EyeX + 8, GameDisplayObject.EyeY + 16)
                GameCreaturesObject.RemoveObjectsAtLocationXY(X.MapX, X.MapY)
                GameCreaturesObject.BoxList.Add(X)
            End If

            ' >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

            If FG Then
                TmpLast = 0
            End If

            If GameDisplayObject.EyeX < 0 Then GameDisplayObject.EyeX = 0
            If GameDisplayObject.EyeX >= (GameMapObject.GameMap.GetLength(0) - 1) * 16 Then GameDisplayObject.EyeX = (GameMapObject.GameMap.GetLength(0) - 1) * 16
            If GameDisplayObject.EyeY < 0 Then GameDisplayObject.EyeY = 0
            If GameDisplayObject.EyeY >= (GameMapObject.GameMap.GetLength(1) - 1) * 16 Then GameDisplayObject.EyeY = (GameMapObject.GameMap.GetLength(1) - 1) * 16



        Loop


    End Sub

End Module
